unit FILAC_Main;

interface

uses
  Winapi.Windows, Winapi.Messages, System.SysUtils, System.Variants, System.Classes, Vcl.Graphics,
  Vcl.Controls, Vcl.Forms, Vcl.Dialogs, Vcl.AppEvnts, System.ImageList, Vcl.ImgList, Vcl.ExtCtrls,
  Vcl.Buttons, Winapi.ActiveX, Winapi.ShlObj, OleDragnDrop, ShellTypes, VistaShellCtrls, FILAC_Nav;

const
  //Filerac Notify Messages
  AM_NOTIFY = WM_APP + WM_NOTIFY;

  //Filerac Notify WPARAM
  FNQueryTailender = 0; //EBhE₢킹          LPARAM=Handle
  FNCnveyTailender = 1; //₢킹ɖł邱Ƃ`  LPARAM=Handle
  FNNextPopurate   = 2; //ςƂOɓ`          LPARAM=Handle
  FNTellColor      = 3; //Fɓ`                        LPARAM=Color
  FNChangeBounds   = 4; //TCY̕ύXɓ`              LPARAM=Handle
  FNPrevVacant     = 5; //OςƂɓ`          LPARAM=FPrevWnd
  FNNextVacant     = 6; //ȂȂƂOɓ`        LPARAM=Handle

type
  TLayout = (loNone, loCollapsed, loExpanded, loPinned);

  TChangePart = (cpConfig, cpForm, cpFrame, cpTree);
  TChangeParts = set of TChangePart;

  TMainForm = class(TForm)
    AppMainEvents: TApplicationEvents;
    TitleImages: TImageList;
    TitlePanel: TPanel;
    OptionBtn: TSpeedButton;
    TopmostBtn: TSpeedButton;
    PinningBtn: TSpeedButton;
    ExitBtn: TSpeedButton;
    ScrollBox: TScrollBox;
    LayoutTimer: TTimer;
    DropTarget: TDropTarget;
    HoverTimer: TTimer;
    procedure AppMainEventsDeactivate(Sender: TObject);
    procedure AppMainEventsIdle(Sender: TObject; var Done: Boolean);
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure FormClick(Sender: TObject);
    procedure FormMouseMove(Sender: TObject; Shift: TShiftState; X, Y: Integer);
    procedure FormCanResize(Sender: TObject; var NewWidth, NewHeight: Integer; var Resize: Boolean);
    procedure FormResize(Sender: TObject);
    procedure TitlePanelMouseDown(Sender: TObject; Button: TMouseButton; Shift: TShiftState; X,
      Y: Integer);
    procedure TitlePanelMouseMove(Sender: TObject; Shift: TShiftState; X, Y: Integer);
    procedure TitlePanelMouseUp(Sender: TObject; Button: TMouseButton; Shift: TShiftState; X,
      Y: Integer);
    procedure OptionBtnClick(Sender: TObject);
    procedure TopmostBtnClick(Sender: TObject);
    procedure PinningBtnClick(Sender: TObject);
    procedure ExitBtnClick(Sender: TObject);
    procedure ScrollBoxDblClick(Sender: TObject);
    procedure LayoutTimerExpanding(Sender: TObject);
    procedure LayoutTimerCollapsing(Sender: TObject);
    procedure DropTargetDTDragEnter(const dataObj: IDataObject; grfKeyState: Integer; pt: TPoint;
      var dwEffect: Integer; var Result: HRESULT);
    procedure DropTargetDTDragOver(grfKeyState: Integer; pt: TPoint; var dwEffect: Integer;
      var Result: HRESULT);
    procedure DropTargetDTDragLeave(var Result: HRESULT);
    procedure DropTargetDTDrop(const dataObj: IDataObject; grfKeyState: Integer; pt: TPoint;
      var dwEffect: Integer; var Result: HRESULT);
    procedure HoverTimerTimeOut(Sender: TObject);
    procedure SplitterCanResize(Sender: TObject; var NewSize: Integer; var Accept: Boolean);
  private
    { Private 錾 }
    FSnapEdge: TAlign;
    FLayout: TLayout;
    FTopmost: Boolean;
    FHitPlace: NativeInt;
    FHoverPos: TPoint;
    FFrames: TList;
    FWasActive: TWinControl;
    FCollapseSize,
    FExpandWidth,
    FExpandHeight: Integer;
    FBaseColor,
    FBlendColor: TColor;
    FColorShift: Boolean;
    FDefaultStyles: TNamespaceTreeControlStyles;
    FDefaultFilters: TShellContactFilters;
    FMaintains,
    FModifies: TChangeParts;
    FPrevWnd,
    FNextWnd: HWND;
    procedure ShowFront;
    procedure MoveFirst(Ctrl: TControl);
    procedure RedrawGlyph(Button: TSpeedButton);
    function IsSimilar(Wnd: HWND): Boolean;
    function PrevExists: Boolean;
    function NextExists: Boolean;
    function CalcBounds(Mon: TMonitor; Edge: TAlign): TRect;
    procedure ColorScheme;
    procedure SetSnapEdge(Value: TAlign);
    procedure SetLayout(Value: TLayout);
    procedure SetTopmost(Value: Boolean);
    procedure SetCollapseSize(Value: Integer);
    procedure SetExpandWidth(Value: Integer);
    procedure SetExpandHeight(Value: Integer);
    procedure SetBaseColor(Value: TColor);
    procedure SetColorShift(Value: Boolean);
    procedure ReadOption;
    procedure WriteOption(Writes: TChangeParts);
    function HitTest(ClientPos: TPoint): NativeInt;
    procedure WMDisplayChange(var Msg: TMessage); message WM_DISPLAYCHANGE;
    procedure WMNCHitTest(var Message: TWMNCHitTest); message WM_NCHITTEST;
    procedure CMColorChanged(var Message: TMessage); message CM_COLORCHANGED;
    procedure AMNotify(var Message: TMessage); message AM_NOTIFY;
  protected
    { protected 錾 }
  public
    { Public 錾 }
    procedure InclModify(Value: TChangePart);
    procedure ExclModify(Value: TChangePart);
    function AddFrame(FrameID: Integer = -1): TNavFrame;
    function AddRoot(AFrame: TNavFrame; APath: TRoot): TNamespaceTreeRoot;
    procedure AddDesktop;
    procedure DelFrame(Frame: TNavFrame);
    procedure MoveFrame(CurFrame, NewFrame: TNavFrame);
    property SnapEdge: TAlign read FSnapEdge write SetSnapEdge;
    property Layout: TLayout read FLayout write SetLayout;
    property Topmost: Boolean read FTopmost write SetTopmost;
    property CollapseSize: Integer read FCollapseSize write SetCollapseSize;
    property ExpandWidth: Integer read FExpandWidth write SetExpandWidth;
    property ExpandHeight: Integer read FExpandHeight write SetExpandHeight;
    property BaseColor: TColor read FBaseColor write SetBaseColor;
    property ColorShift: Boolean read FColorShift write SetColorShift;
    property DefaultStyles: TNamespaceTreeControlStyles read FDefaultStyles write FDefaultStyles;
    property DefaultFilters: TShellContactFilters read FDefaultFilters write FDefaultFilters;
    property Maintains: TChangeParts read FMaintains write FMaintains;
    property Modifies: TChangeParts read FModifies write FModifies;
  end;

function IsDark(Color: TColor): Boolean;
function EnumNTCS(Value: Integer): TNamespaceTreeControlStyles;
function NumNTCS(Value: TNamespaceTreeControlStyles): Integer;
function EnumSCF(Value: Byte): TShellContactFilters;
function NumSCF(Value: TShellContactFilters): Byte;
function EnumCP(Value: Byte): TChangeParts;
function NumCP(Value: TChangeParts): Byte;

const
  LeastWidht = 300;
  LeastHeight = 225;
  FrameSize = 3;

var
  MainForm: TMainForm;
  XMLFileName: string;

implementation

{$R *.dfm}

uses
  FILAC_Config,
  System.Types, System.UITypes, WndInfo, AppData, ShellUtils, Winapi.ShellAPI;

resourcestring
  STopmost =  'ɍőOʂŕ\';
  SNormal =   'W`ŕ\';
  SPinning =  'WJČŒ';
  SFloating = 'Ő܂';

{ TNavFrame.Name managment }

resourcestring
  SDuplicateID = 'Id.%d ͂łɎgĂ܂';

var
  FrameCounter: TBits;

function CheckVacant(ID: Integer): Boolean;
begin
  if ID >= FrameCounter.Size then
    FrameCounter.Size := ID + 4;
  Result := not FrameCounter.Bits[ID];
end;

function CheckIn(ID: Integer = -1): Integer;
begin
  if ID < 0 then
  begin
    ID := FrameCounter.OpenBit;
    FrameCounter.Bits[ID] := True;
    Result := ID;
  end
  else
  begin
    if CheckVacant(ID) then
    begin
      FrameCounter.Bits[ID] := True;
      Result := ID;
    end
    else
      raise EBitsError.CreateResFmt(@SDuplicateID, [ID]);
  end;
end;

procedure CheckOut(ID: Integer);
begin
  FrameCounter.Bits[ID] := False;
end;

{ Routine }

function IsDark(Color: TColor): Boolean;
begin
  with TColorRec(ColorToRGB(Color)) do
    Result := (R + G + B) / 3 < 128;
end;

function EnumNTCS(Value: Integer): TNamespaceTreeControlStyles;
var
  Styles: TNamespaceTreeControlStyles;
  StylesBuf: Integer absolute Styles;
begin
  StylesBuf := Value;
  Result := Styles;
end;

function NumNTCS(Value: TNamespaceTreeControlStyles): Integer;
var
  Styles: TNamespaceTreeControlStyles;
  StylesBuf: Integer absolute Styles;
begin
  Styles := Value;
  Result := StylesBuf;
end;

function EnumSCF(Value: Byte): TShellContactFilters;
var
  Flags: TShellContactFilters;
  FlagsBuf: Byte absolute Flags;
begin
  FlagsBuf := Value;
  Result := Flags;
end;

function NumSCF(Value: TShellContactFilters): Byte;
var
  Flags: TShellContactFilters;
  FlagsBuf: Byte absolute Flags;
begin
  Flags := Value;
  Result := FlagsBuf;
end;

function EnumCP(Value: Byte): TChangeParts;
var
  Flags: TChangeParts;
  FlagsBuf: Byte absolute Flags;
begin
  FlagsBuf := Value;
  Result := Flags;
end;

function NumCP(Value: TChangeParts): Byte;
var
  Flags: TChangeParts;
  FlagsBuf: Byte absolute Flags;
begin
  Flags := Value;
  Result := FlagsBuf;
end;

{ TMainForm }

procedure TMainForm.ShowFront;
const
  Flags = SWP_NOMOVE or SWP_NOSIZE or SWP_NOSENDCHANGING or SWP_SHOWWINDOW;
begin
  SetWindowPos(Handle, HWND_TOPMOST, 0, 0, 0, 0, Flags);
  if not Topmost then
    SetWindowPos(Handle, HWND_NOTOPMOST, 0, 0, 0, 0, Flags);
end;

procedure TMainForm.MoveFirst(Ctrl: TControl);
begin
  case SnapEdge of
    alTop, alBottom:
    begin
      if Ctrl is TNavFrame then //Ctrl ̂܂܂ƌp Align Ă΂ȂB
        TNavFrame(Ctrl).Align := alLeft
      else
        Ctrl.Align := alLeft;
      Ctrl.Left := 0;
    end;
    alLeft, alRight:
    begin
      if Ctrl is TNavFrame then
        TNavFrame(Ctrl).Align := alTop
      else
        Ctrl.Align := alTop;
      Ctrl.Top := 0;
    end;
  end;
  if Ctrl is TNavFrame then
    TNavFrame(Ctrl).Realign;
end;

procedure TMainForm.RedrawGlyph(Button: TSpeedButton);
var
  Bmp: TBitmap;
begin
  if Assigned(TitleImages) then
  begin
    Bmp := TBitmap.Create;
    try
      Bmp.PixelFormat := pf4bit;
      TitleImages.GetBitmap(Button.Tag, Bmp);
      Button.Glyph.Assign(Bmp);

      if IsDark(Color) then
      begin
        Button.Glyph.Canvas.CopyMode := cmDstInvert;
        Button.Glyph.Canvas.CopyRect(Rect(0, 0, 16, 16), Bmp.Canvas, Rect(0, 0, 16, 16));
      end;
    finally
      Bmp.Free;
    end;
  end;
end;

function TMainForm.IsSimilar(Wnd: HWND): Boolean;
begin
  Result := (Wnd <> Handle) and IsWindow(Wnd) and MatchesWindow(Wnd, ClassName, Caption);
end;

function TMainForm.PrevExists: Boolean;
begin
  Result := IsSimilar(FPrevWnd);
  if not Result and (FPrevWnd <> Handle) then
  begin
    FPrevWnd := Handle;
    FBlendColor := clNone;
  end;
end;

function TMainForm.NextExists: Boolean;
begin
  Result := IsSimilar(FNextWnd);
  if not Result and (FNextWnd <> Handle) then
    FNextWnd := Handle;
end;

function TMainForm.CalcBounds(Mon: TMonitor; Edge: TAlign): TRect;
var
  WorkRt, PrevRt: TRect;
begin
  WorkRt := Mon.WorkareaRect;
  if PrevExists then
  begin
    GetWindowRect(FPrevWnd, PrevRt);
    case Edge of
      alTop: WorkRt.Top := PrevRt.Bottom;
      alBottom: WorkRt.Bottom := PrevRt.Top;
      alLeft: WorkRt.Left := PrevRt.Right;
      alRight: WorkRt.Right := PrevRt.Left;
    end;
  end;
  case Edge of
    alTop:
    begin
      if Layout = loCollapsed then
        Result := Bounds(WorkRt.Left, WorkRt.Top, WorkRt.Width, FCollapseSize)
      else
        Result := Bounds(WorkRt.Left, WorkRt.Top, WorkRt.Width, FExpandHeight);
    end;
    alBottom:
    begin
      if Layout = loCollapsed then
        Result := Bounds(WorkRt.Left, WorkRt.Bottom - FCollapseSize, WorkRt.Width, FCollapseSize)
      else
        Result := Bounds(WorkRt.Left, WorkRt.Bottom - FExpandHeight, WorkRt.Width, FExpandHeight);
    end;
    alLeft:
    begin
      if Layout = loCollapsed then
        Result := Bounds(WorkRt.Left, WorkRt.Top, FCollapseSize, WorkRt.Height)
      else
        Result := Bounds(WorkRt.Left, WorkRt.Top, FExpandWidth, WorkRt.Height);
    end;
    alRight:
    begin
      if Layout = loCollapsed then
        Result := Bounds(WorkRt.Right - FCollapseSize, WorkRt.Top, FCollapseSize, WorkRt.Height)
      else
        Result := Bounds(WorkRt.Right - FExpandWidth, WorkRt.Top, FExpandWidth, WorkRt.Height);
    end
  else
    Result := BoundsRect;
  end;
end;

procedure TMainForm.ColorScheme;
const
  Margin = 32;
  Offset = 64;

  function SameRGB(A, B: Integer): Boolean;
  begin
    Result := (A - Margin <= B) and (B <= A + Margin);
  end;

var
  NewColor: TColor;
  R1, G1, B1: Byte;
  R2, G2, B2: Byte;
  R3, G3, B3: Byte;
begin
  NewColor := FBaseColor;
  if FBlendColor <> clNone then
  begin
    with TColorRec(ColorToRGB(FBaseColor)) do
    begin
      R1 := R;
      G1 := G;
      B1 := B;
    end;

    with TColorRec(ColorToRGB(FBlendColor)) do
    begin
      R2 := R;
      G2 := G;
      B2 := B;
    end;

    if SameRGB(R1, R2) and SameRGB(G1, G2) and SameRGB(B1, B2) then
    begin
      R3 := R1 + R2;
      if SameRGB(R3, R1) then
      begin
        if R3 < 128 then
          Inc(R3, Offset)
        else
          Dec(R3, Offset);
      end;
      G3 := G1 + G2;
      if SameRGB(G3, G1) then
      begin
        if G3 < 128 then
          Inc(G3, Offset)
        else
          Dec(G3, Offset);
      end;
      B3 := B1 + B2;
      if SameRGB(B3, B1) then
      begin
        if B3 < 128 then
          Inc(B3, Offset)
        else
          Dec(B3, Offset);
      end;
    end
    else
    begin
      R3 := R1;
      G3 := G1;
      B3 := B1;
    end;
    NewColor := RGB(R3, G3, B3);
  end;
  if Color <> NewColor then
  begin
    Color := NewColor;

    if NextExists then
      PostMessage(FNextWnd, AM_NOTIFY, FNTellColor, Color);
  end;
end;

function EnumWindowsProc(hwnd: HWND; lParam: LPARAM): BOOL; stdcall;
var
  Rt: TRect;
  Underlap: Boolean;
begin
  Result := True;
  with MainForm do
    if IsSimilar(hwnd) then
    begin
      if lParam = GetWindowLong(hwnd, GWL_USERDATA) then
      begin
        GetWindowRect(hwnd, Rt);
        case TAlign(lParam) of
          alTop: Underlap := (BoundsRect.TopLeft = Rt.TopLeft) and (Width = Rt.Width);
          alBottom: Underlap := (BoundsRect.BottomRight = Rt.BottomRight) and (Width = Rt.Width);
          alLeft: Underlap := (BoundsRect.TopLeft = Rt.TopLeft) and (Height = Rt.Height);
          alRight: Underlap := (BoundsRect.BottomRight = Rt.BottomRight) and (Height = Rt.Height);
        else
          Underlap := False;
        end;
        if Underlap then
        begin
          PostMessage(hwnd, AM_NOTIFY, FNQueryTailender, Handle);

          Result := False;
        end;
      end;
    end;
end;

procedure TMainForm.SetSnapEdge(Value: TAlign);
var
  Mon: TMonitor;
  NewRt: TRect;
  i: Integer;
begin
  if GetKeyState(VK_LBUTTON) < 0 then
    Mon := Screen.MonitorFromPoint(Mouse.CursorPos, mdNearest)
  else
    Mon := Monitor;
  NewRt := CalcBounds(Mon, Value);
  if (NewRt <> BoundsRect) or (Value <> FSnapEdge) then
  begin
    if NextExists then
      PostMessage(FNextWnd, AM_NOTIFY, FNPrevVacant, FPrevWnd)
    else if PrevExists then
      PostMessage(FPrevWnd, AM_NOTIFY, FNNextVacant, Handle);
    FPrevWnd := Handle;
    FNextWnd := Handle;

    BoundsRect := NewRt;
    EnumWindows(@EnumWindowsProc, Ord(Value));

    if Value <> FSnapEdge then
    begin
      FSnapEdge := Value;
      SetWindowLong(Handle, GWL_USERDATA, Ord(FSnapEdge));

      with Padding do
      begin
        if FSnapEdge = alTop then Top := 0 else Top := FrameSize;
        if FSnapEdge = alBottom then Bottom := 0 else Bottom := FrameSize;
        if FSnapEdge = alLeft then Left := 0 else Left := FrameSize;
        if FSnapEdge = alRight then Right := 0 else Right := FrameSize;
      end;

      TitlePanel.Align := FSnapEdge;
      case TitlePanel.Align of
        alTop, alBottom:
        begin
          TitlePanel.Font.Orientation := 0;
          ExitBtn.Align := alRight;
          PinningBtn.Align := alRight;
          PinningBtn.Left := ExitBtn.Left - PinningBtn.Width - 1;
          TopmostBtn.Align := alRight;
          TopmostBtn.Left := PinningBtn.Left - PinningBtn.Width - 1;
          OptionBtn.Align := alLeft;
        end;
        alLeft, alRight:
        begin
          TitlePanel.Font.Orientation := 900;
          ExitBtn.Align := alTop;
          PinningBtn.Align := alTop;
          PinningBtn.Top := ExitBtn.BoundsRect.Bottom + 1;
          TopmostBtn.Align := alTop;
          TopmostBtn.Top := PinningBtn.BoundsRect.Bottom + 1;
          OptionBtn.Align := alBottom;
        end;
      end;
      for i := FFrames.Count - 1 downto 0 do
        MoveFirst(TControl(FFrames.Items[i]));
    end;
    InclModify(cpForm);
  end;
end;

procedure TMainForm.SetLayout(Value: TLayout);

  procedure Pinning(Pin: Boolean);
  var
    NewTag: NativeInt;
  begin
    if Pin then
      NewTag := 4
    else
      NewTag := 3;
    if NewTag <> PinningBtn.Tag then
    begin
      PinningBtn.Tag := NewTag;
      case PinningBtn.Tag of
        3: PinningBtn.Hint := SFloating;
        4: PinningBtn.Hint := SPinning;
      end;
      RedrawGlyph(PinningBtn);
      InclModify(cpForm);
    end;
  end;

var
  OldLayout: TLayout;
begin
  if Value <> FLayout then
  begin
    OldLayout := FLayout;
    FLayout := Value;
    case FLayout of
      loCollapsed:
      begin
        Pinning(False);

        FWasActive := ActiveControl;
        TitlePanel.Hide;
        ScrollBox.Hide;
        AlphaBlend := True;
        case SnapEdge of
          alTop:
          begin
            FExpandHeight := Height;
            SetBounds(Left, Top, Width, FCollapseSize);
          end;
          alBottom:
          begin
            FExpandHeight := Height;
            SetBounds(Left, Monitor.WorkareaRect.Bottom - FCollapseSize, Width, FCollapseSize);
          end;
          alLeft:
          begin
            FExpandWidth := Width;
            SetBounds(Left, Top, FCollapseSize, Height);
          end;
          alRight:
          begin
            FExpandWidth := Width;
            SetBounds(Monitor.WorkareaRect.Right - FCollapseSize, Top, FCollapseSize, Height);
          end;
        end;
      end;
      loExpanded, loPinned:
      begin
        if OldLayout = loCollapsed then
        begin
          ShowFront;
          TitlePanel.Show;
          ScrollBox.Show;
          if Assigned(FWasActive) then
            FWasActive.SetFocus;
          AlphaBlend := False;
          case SnapEdge of
            alTop: SetBounds(Left, Top, Width, FExpandHeight);
            alBottom: SetBounds(Left, Monitor.WorkareaRect.Bottom - FExpandHeight, Width, FExpandHeight);
            alLeft: SetBounds(Left, Top, FExpandWidth, Height);
            alRight: SetBounds(Monitor.WorkareaRect.Right - FExpandWidth, Top, FExpandWidth, Height);
          end;
        end;
        Pinning(FLayout = loPinned);
      end;
    end;
  end;
end;

procedure TMainForm.SetTopmost(Value: Boolean);
var
  NewTag: NativeInt;
begin
  if Value <> FTopmost then
  begin
    FTopmost := Value;
    if FTopmost then
      NewTag := 2
    else
      NewTag := 1;
    TopmostBtn.Tag := NewTag;
    case TopmostBtn.Tag of
      1: TopmostBtn.Hint := SNormal;
      2: TopmostBtn.Hint := STopmost;
    end;
    RedrawGlyph(TopmostBtn);
    ShowFront;
    InclModify(cpForm);
  end;
end;

procedure TMainForm.SetCollapseSize(Value: Integer);
begin
  if Value <> FCollapseSize then
  begin
    FCollapseSize := Value;
    if Layout = loCollapsed then
    begin
      case SnapEdge of
        alTop: Height := FCollapseSize;
        alBottom: Height := FCollapseSize;
        alLeft: Width := FCollapseSize;
        alRight: Width := FCollapseSize;
      end;

      if NextExists then
        PostMessage(FNextWnd, AM_NOTIFY, FNChangeBounds, Handle);
    end;
    InclModify(cpForm);
  end;
end;

procedure TMainForm.SetExpandWidth(Value: Integer);
begin
  if Value <> FExpandWidth then
  begin
    FExpandWidth := Value;
    if (Layout <> loCollapsed) and (SnapEdge in [alLeft, alRight]) then
      Width := FExpandWidth;
    InclModify(cpForm);
  end;
end;

procedure TMainForm.SetExpandHeight(Value: Integer);
begin
  if Value <> FExpandHeight then
  begin
    FExpandHeight := Value;
    if (Layout <> loCollapsed) and (SnapEdge in [alTop, alBottom]) then
      Height := FExpandHeight;
    InclModify(cpForm);
  end;
end;

procedure TMainForm.SetBaseColor(Value: TColor);
begin
  if Value <> FBaseColor then
  begin
    FBaseColor := Value;
    ColorScheme;
    InclModify(cpForm);
  end;
end;

procedure TMainForm.SetColorShift(Value: Boolean);
begin
  if Value <> FColorShift then
  begin
    FColorShift := Value;
    ColorScheme;
    InclModify(cpForm);
  end;
end;

procedure TMainForm.InclModify(Value: TChangePart);
begin
  Include(FModifies, Value);
end;

procedure TMainForm.ExclModify(Value: TChangePart);
begin
  Exclude(FModifies, Value);
end;

function TMainForm.AddFrame(FrameID: Integer = -1): TNavFrame;
var
  NewID: Integer;
  NewSplitter: TSplitter;
begin
  NewID := CheckIn(FrameID);
  Result := TNavFrame.Create(Self, NewID);
  Result.Name := 'Frame' + IntToStr(NewID); //OdȂ悤ɕύXB
  Result.Parent := ScrollBox;
  Result.Collapsed := False;
  Result.NameSpaceTree.Styles := DefaultStyles;
  case SnapEdge of
    alTop, alBottom:
    begin
      Result.Align := alLeft;
      if FFrames.Count > 0 then
        Result.Left := TControl(FFrames.Last).BoundsRect.Right + 1;
    end;
    alLeft, alRight:
    begin
      Result.Align := alTop;
      if FFrames.Count > 0 then
        Result.Top := TControl(FFrames.Last).BoundsRect.Bottom + 1;
    end;
  end;
  FFrames.Add(Result);

  NewSplitter := TSplitter.Create(Self);
  NewSplitter.Name := 'Splitter' + IntToStr(NewID); //ꉞB
  NewSplitter.Parent := ScrollBox;
  NewSplitter.AutoSnap := False;
  NewSplitter.MinSize := 3;
  //! NewSplitter.Beveled := True;
  NewSplitter.OnCanResize := SplitterCanResize;
  case SnapEdge of
    alTop, alBottom:
    begin
      NewSplitter.Align := alLeft;
      if FFrames.Count > 0 then
        NewSplitter.Left :=TControl(FFrames.Last).BoundsRect.Right + 1;
    end;
    alLeft, alRight:
    begin
      NewSplitter.Align := alTop;
      if FFrames.Count > 0 then
        NewSplitter.Top := TControl(FFrames.Last).BoundsRect.Bottom + 1;
    end;
  end;
  FFrames.Add(NewSplitter);
  InclModify(cpFrame);
end;

function TMainForm.AddRoot(AFrame: TNavFrame; APath: TRoot): TNamespaceTreeRoot;
begin
  if not Assigned(AFrame) then
    AFrame := AddFrame;

  Result := AFrame.NameSpaceTree.Roots.Add;
  Result.Styles := [];
  Result.Filters := DefaultFilters;
  Result.Path := APath;
  InclModify(cpFrame);
end;

procedure TMainForm.AddDesktop;
var
  NewFrame: TNavFrame;
  NewSize: Integer;
  NewRoot: TNamespaceTreeRoot;
begin
  NewFrame := AddFrame;
  case SnapEdge of
    alTop, alBottom: ;
    alLeft, alRight:
    begin
      NewSize := ScrollBox.ClientHeight - NewFrame.Top - 3;
      if NewSize < LeastHeight then
        NewSize := LeastHeight;
      NewFrame.ExpandHeight := NewSize;
    end;
  end;
  NewRoot := AddRoot(NewFrame, '');
  NewRoot.Styles := [nstcrsExpanded];
  NewRoot.Path := 'rfDesktop';
  ExclModify(cpFrame);
end;

procedure TMainForm.DelFrame(Frame: TNavFrame);
begin
  CheckOut(Frame.ID);
  with FFrames do
  begin
    TSplitter(Extract(Items[IndexOf(Frame) + 1])).Free;

    TNavFrame(Extract(Frame)).Free;
  end;
  InclModify(cpFrame);
end;

procedure TMainForm.MoveFrame(CurFrame, NewFrame: TNavFrame);
var
  CurIndex, NewIndex: Integer;
  CurSplitter: TSplitter;
  i: Integer;
begin
  CurIndex := FFrames.IndexOf(CurFrame);
  CurSplitter := TSplitter(FFrames.Items[CurIndex + 1]);
  NewIndex := FFrames.IndexOf(NewFrame);
  if CurIndex < NewIndex then
    Inc(NewIndex);
  FFrames.Move(CurIndex, NewIndex);

  CurIndex := FFrames.IndexOf(CurSplitter);
  NewIndex := FFrames.IndexOf(CurFrame);
  if CurIndex > NewIndex then
    Inc(NewIndex);
  FFrames.Move(CurIndex, NewIndex);

  for i := FFrames.Count - 1 downto 0 do
    MoveFirst(TControl(FFrames.Items[i]));
  InclModify(cpFrame);
end;

procedure TMainForm.ReadOption;
var
  RegFile: TXMLRegFile;
  Frames, Roots: TStrings;
  Frame: TNavFrame;
  FramePath, RootPath: string;
  Root: TNamespaceTreeRoot;
  i, j: Integer;
begin
  RegFile := TXMLRegFile.Create(XMLFileName);
  try
    if RegFile.OpenNode('\Configuration', True) then
    begin
      FCollapseSize := RegFile.ReadIntDef('CollapseSize', 4);
      FExpandWidth := RegFile.ReadIntDef('ExpandWidth', LeastWidht);
      FExpandHeight := RegFile.ReadIntDef('ExpandHeight', LeastHeight);
      BaseColor := RegFile.ReadIntDef('BaseColor', clBtnFace);
      ColorShift := RegFile.ReadBoolDef('ColorShift', True);
      AlphaBlendValue := RegFile.ReadIntDef('AlphaBlendValue', 64);
      FDefaultStyles :=  EnumNTCS(RegFile.ReadIntDef('DefaultStyles', 65633));  //nstcsHasExpandos, nstcsHorizontalScroll, nstcsRootHasExpando, nstcsTabStop
      FDefaultFilters := EnumSCF(RegFile.ReadIntDef('DefaultFilters', 6)); //shcontfFolders, shcontfNonFolders
      FMaintains := EnumCP(RegFile.ReadIntDef('Maintains', 0));
    end;
    if RegFile.OpenNode('\Snapshot', True) then
    begin
      Left := RegFile.ReadIntDef('Left', 0);
      Top := RegFile.ReadIntDef('Top', 0);
      Width := RegFile.ReadIntDef('Width', FExpandWidth);
      Height := RegFile.ReadIntDef('Height', FExpandHeight);
      SnapEdge := TAlign(RegFile.ReadIntDef('SnapEdge', 3));  //alLeft
      Layout := TLayout(RegFile.ReadIntDef('Layout', 1));  //loCollapsed;
      Topmost := RegFile.ReadBoolDef('Topmost', False);
      if RegFile.OpenNode('\Snapshot\Frames', True) then
      begin
        Frames := TStringList.Create;
        try
          RegFile.GetNodeNames(Frames);
          for i := 0 to Frames.Count - 1 do
          begin
            Frame := AddFrame(StrToInt(Copy(Frames.Strings[i], 4, MAX_PATH)));
            FramePath := '\Snapshot\Frames\' + Frames.Strings[i];
            if RegFile.OpenNode(FramePath, True) then
            begin
              Frame.ExpandWidth := RegFile.ReadIntDef('ExpandWidth', LeastWidht);
              Frame.ExpandHeight := RegFile.ReadIntDef('ExpandHeight', LeastHeight);
              Frame.NameSpaceTree.Styles := EnumNTCS(RegFile.ReadIntDef('Styles', 65633));
            end;
            if RegFile.OpenNode(FramePath + '\Tree', True) then
            begin
              Frame.Width := RegFile.ReadIntDef('Width', Frame.ExpandWidth);
              Frame.Height := RegFile.ReadIntDef('Height', Frame.ExpandHeight);
              Frame.Collapsed := RegFile.ReadBoolDef('Collapsed', False);
            end;
            if RegFile.OpenNode(FramePath + '\Tree\Roots', True) then
            begin
              Roots := TStringList.Create;
              try
                RegFile.GetNodeNames(Roots);
                for j := 0 to Roots.Count - 1 do
                begin
                  RootPath := FramePath + '\Tree\Roots\' + Roots.Strings[j];
                  if RegFile.OpenNode(RootPath, True) then
                  begin
                    Root := AddRoot(Frame, '');
                    Root.Filters := EnumSCF(RegFile.ReadIntDef('Filters', 6));
                    Root.Path := RegFile.ReadStrDef('Path', 'rfDesktop');
                  end;
                end;
                //tH_̏ԕ TNavFrame.NameSpaceTreeTreeCreate ōsB
                Frame.AppNavEvents.OnIdle := Frame.AppNavEventsIdleAtCreate;
              finally
                Roots.Free;
              end;
            end;
          end;
        finally
          Frames.Free;
        end;
      end;
    end;
  finally
    RegFile.Free;
  end;
  if FFrames.Count = 0 then
    AddDesktop;
  FModifies := [];
end;

procedure TMainForm.WriteOption(Writes: TChangeParts);
var
  RegFile: TXMLRegFile;
  i, j, SelIndex: Integer;
  Frame: TNavFrame;
  Roots: TNamespaceTreeRoots;
  FramePath, RootPath: string;
begin
  if not (cpConfig in Writes) then ExclModify(cpConfig);
  if not (cpForm in Writes) then ExclModify(cpForm);
  if not (cpFrame in Writes) then ExclModify(cpFrame);
  if not (cpTree in Writes) then ExclModify(cpTree);
  if FModifies = [] then Exit;

  RegFile := TXMLRegFile.Create(XMLFileName);
  try
    if (cpConfig in Modifies) and RegFile.OpenNode('\Configuration', True) then
    begin
      RegFile.WriteInteger('CollapseSize', CollapseSize);
      RegFile.WriteInteger('ExpandWidth', ExpandWidth);
      RegFile.WriteInteger('ExpandHeight', ExpandHeight);
      RegFile.WriteInteger('BaseColor', BaseColor);
      RegFile.WriteBool('ColorShift', ColorShift);
      RegFile.WriteInteger('AlphaBlendValue', AlphaBlendValue);
      RegFile.WriteInteger('DefaultStyles', NumNTCS(DefaultStyles));
      RegFile.WriteInteger('DefaultFilters', NumSCF(DefaultFilters));
      RegFile.WriteInteger('Maintains', NumCP(FMaintains));
    end;
    if ((cpForm in Modifies) or (cpFrame in Modifies) or (cpTree in Modifies))
      and RegFile.OpenNode('\Snapshot', True) then
    begin
      if cpForm in Modifies then
      begin
        RegFile.WriteInteger('Left', Left);
        RegFile.WriteInteger('Top', Top);
        RegFile.WriteInteger('Width', Width);
        RegFile.WriteInteger('Height', Height);
        RegFile.WriteInteger('SnapEdge', Ord(SnapEdge));
        RegFile.WriteInteger('Layout', Ord(Layout));
        RegFile.WriteBool('Topmost', Topmost);
      end;
      if (cpFrame in Modifies) or (cpTree in Modifies) then
      begin
        if Assigned(ActiveControl) and (ActiveControl is TNameSpaceTreeControl) then
          RegFile.WriteInteger('ActiveFrame', TNavFrame(ActiveControl.Parent).ID)
        else
          RegFile.WriteInteger('ActiveFrame', 0);
        if cpFrame in Modifies then
          RegFile.ClearNodes;
        for i := 0 to FFrames.Count - 1 do
        begin
          if TObject(FFrames.Items[i]) is TNavFrame then
          begin
            Frame := TNavFrame(FFrames.Items[i]);
            FramePath := '\Snapshot\Frames\Id.' + IntToStr(Frame.ID);
            if (cpFrame in Modifies) and RegFile.OpenNode(FramePath, True) then
            begin
              RegFile.WriteInteger('ExpandWidht', Frame.ExpandWidth);
              RegFile.WriteInteger('ExpandHeight', Frame.ExpandHeight);
              RegFile.WriteInteger('Styles', NumNTCS(Frame.NameSpaceTree.Styles));
            end;
            if (cpFrame in Modifies) and RegFile.OpenNode(FramePath + '\Tree', True) then
            begin
              RegFile.WriteInteger('Widht', Frame.Width);
              RegFile.WriteInteger('Height', Frame.Height);
              RegFile.WriteBool('Collapsed', Frame.Collapsed);
            end;
            if Assigned(Frame.Selected) then
              SelIndex := Frame.RootAs(Frame.TrackRoot(Frame.Selected)).Index
            else
              SelIndex := -1;
            Roots := Frame.NameSpaceTree.Roots;
            for j := 0 to Roots.Count - 1 do
            begin
              RootPath := FramePath + '\Tree\Roots\No.' + IntToStr(j);
              if (cpFrame in Modifies) and RegFile.OpenNode(RootPath, True) then
              begin
                RegFile.WriteString('Path', Roots.Items[j].Path);
                RegFile.WriteInteger('Filters', NumSCF(Roots.Items[j].Filters));
              end;
              if (cpTree in Modifies) and RegFile.OpenNode(RootPath, True) then
              begin
                Frame.StoreReserves(Roots.Items[j].SHItem, nil, nil);
                if Frame.ExpandingReserves.Count > 0 then
                  RegFile.WriteString('Expands', Frame.ExpandingReserves.CommaText)
                else
                  RegFile.DeleteValue('Expands');
                Frame.ExpandingReserves.Clear;
                if SelIndex = j then
                  RegFile.WriteString('Selected', GetVerbosePath(Frame.Selected))
                else
                  RegFile.DeleteValue('Selected');
              end;
            end;
          end;
        end;
      end;
    end;
  finally
    RegFile.Free;
  end;
  FModifies := [];
end;

function TMainForm.HitTest(ClientPos: TPoint): NativeInt;
var
  Rt: TRect;
begin
  Rt := BoundsRect;
  if Rt.Contains(ClientPos) then
  begin
    Rt.Inflate(-FCollapseSize, -FCollapseSize);
    if ClientPos.X < Rt.Left then
      Result := HTLEFT
    else if ClientPos.X > Rt.Right then
      Result := HTRIGHT
    else if ClientPos.Y < Rt.Top then
      Result := HTTOP
    else if ClientPos.Y > Rt.Bottom then
      Result := HTBOTTOM
    else
      Result := HTCLIENT;
  end
  else
    Result := HTNOWHERE;
end;

procedure TMainForm.WMDisplayChange(var Msg: TMessage);
begin
  BoundsRect := CalcBounds(Monitor, SnapEdge);
  if PrevExists then
    PostMessage(FNextWnd, AM_NOTIFY, FNChangeBounds, Handle);
end;

procedure TMainForm.WMNCHitTest(var Message: TWMNCHitTest);
begin
  inherited;

  FHitPlace := HTCLIENT;
  Cursor := crDefault;
  if Layout in [loExpanded, loPinned] then
  begin
    case SnapEdge of
      alTop:
        if HitTest(Point(Message.XPos, Message.YPos)) = HTBOTTOM then
        begin
          FHitPlace := HTBOTTOM;
          Cursor := crSizeNS;
        end;
      alBottom:
        if HitTest(Point(Message.XPos, Message.YPos)) = HTTOP then
        begin
          FHitPlace := HTTOP;
          Cursor := crSizeNS;
        end;
      alLeft:
        if HitTest(Point(Message.XPos, Message.YPos)) = HTRIGHT then
        begin
          FHitPlace := HTRIGHT;
          Cursor := crSizeWE;
        end;
      alRight:
        if HitTest(Point(Message.XPos, Message.YPos)) = HTLEFT then
        begin
          FHitPlace := HTLEFT;
          Cursor := crSizeWE;
        end;
    end;
    //! Message.Result := FHitPlace;
  end;
end;

procedure TMainForm.CMColorChanged(var Message: TMessage);
begin
  inherited;

  RedrawGlyph(OptionBtn);
  RedrawGlyph(TopmostBtn);
  RedrawGlyph(PinningBtn);
  RedrawGlyph(ExitBtn);
end;

procedure TMainForm.AMNotify(var Message: TMessage);
begin
  inherited;

  case Message.WParam of
    FNQueryTailender:
    begin
      if NextExists then
        PostMessage(FNextWnd, AM_NOTIFY, FNQueryTailender, Message.LParam)
      else
        PostMessage(Message.LParam, AM_NOTIFY, FNCnveyTailender, Handle);
    end;
    FNCnveyTailender:
    begin
      FPrevWnd := Message.LParam;
      FNextWnd := Handle;
      BoundsRect := CalcBounds(Monitor, SnapEdge);
      //! if PrevExists then
        PostMessage(FPrevWnd, AM_NOTIFY, FNNextPopurate, Handle);
    end;
    FNNextPopurate:
    begin
      FNextWnd := Message.LParam;
      //! if NextExists then
        PostMessage(FNextWnd, AM_NOTIFY, FNTellColor, Color);
    end;
    FNTellColor:
    begin
      FBlendColor := Message.LParam;
      ColorScheme;
    end;
    FNChangeBounds:
    begin
      BoundsRect := CalcBounds(Monitor, SnapEdge);
      if NextExists then
        PostMessage(FNextWnd, AM_NOTIFY, FNChangeBounds, Handle);
    end;
    FNPrevVacant:
    begin
      if FPrevWnd = HWND(Message.LParam) then
        FPrevWnd := Handle
      else
        FPrevWnd := Message.LParam;
      BoundsRect := CalcBounds(Monitor, SnapEdge);
      if FPrevWnd <> Handle then
        PostMessage(FPrevWnd, AM_NOTIFY, FNNextPopurate, Handle);
      if NextExists then
        PostMessage(FNextWnd, AM_NOTIFY, FNChangeBounds, Handle);
    end;
    FNNextVacant:
    begin
      FNextWnd := Handle;
    end;
  end;
end;

procedure TMainForm.AppMainEventsDeactivate(Sender: TObject);
begin
  if Layout = loExpanded then
  begin
    LayoutTimer.Enabled := False;

    Layout := loCollapsed;
  end;
end;

procedure TMainForm.AppMainEventsIdle(Sender: TObject; var Done: Boolean);
begin
  if not LayoutTimer.Enabled then
    case Layout of
      loCollapsed:
      begin
        LayoutTimer.OnTimer := LayoutTimerExpanding;
        LayoutTimer.Enabled := True;
      end;
      loExpanded:
      begin
        LayoutTimer.OnTimer := LayoutTimerCollapsing;
        LayoutTimer.Enabled := True;
      end;
    end;
end;

procedure TMainForm.FormCreate(Sender: TObject);
var
  Metrics: TNonClientMetrics;
  Delay: Integer;
begin
  FHitPlace := HTCLIENT;
  FHoverPos := TPoint.Zero;
  FFrames := TList.Create;
  FWasActive := nil;
  FBlendColor := clNone;
  FPrevWnd := Handle;
  FNextWnd := Handle;
  FModifies := [];

  if TOSVersion.Check(6) then
    ChangeWindowMessageFilter(AM_NOTIFY, MSGFLT_ADD);
  //}EXbZ[WE悤ɌԂJB
  with Padding do
  begin
    Bottom := FrameSize;
    Left := FrameSize;
    Right := FrameSize;
    Top := FrameSize;
  end;
  //^Cg̃tHgVXẽLvVtHgɕύXB
  Metrics.cbSize := SizeOf(Metrics);
  if SystemParametersInfo(SPI_GETNONCLIENTMETRICS, 0, @Metrics, 0) then
    TitlePanel.Font.Handle := CreateFontIndirect(Metrics.lfCaptionFont);
  TitlePanel.Caption := ChangeFileExt(ExtractFileName(ParamStr(0)), '');
  //xԂݒB
  if not SystemParametersInfo(SPI_GETMENUSHOWDELAY, 0, @Delay, 0) then
    Delay := 400;
  LayoutTimer.Interval := Delay;
  //OLE Drag'nDrop JnB
  OleInitialize(nil);
  RegisterDragDrop(Handle, DropTarget);

  ReadOption;
  AppMainEvents.OnDeactivate := AppMainEventsDeactivate;
  AppMainEvents.OnIdle := AppMainEventsIdle;
end;

procedure TMainForm.FormDestroy(Sender: TObject);
begin
  WriteOption(Maintains);

  if NextExists then
    PostMessage(FNextWnd, AM_NOTIFY, FNPrevVacant, FPrevWnd)
  else if PrevExists then
    PostMessage(FPrevWnd, AM_NOTIFY, FNNextVacant, FPrevWnd);

  RevokeDragDrop(Handle);
  OleUninitialize;
  FFrames.Free;
end;

procedure TMainForm.FormShow(Sender: TObject);
begin
  //OIɃX^[gAbvNƁA^XNo[{^\邽ߏB
  ShowWindow(Application.Handle, SW_HIDE);
end;

procedure TMainForm.FormClick(Sender: TObject);
begin
  if Layout = loCollapsed then
  begin
    LayoutTimer.Enabled := False;

    Layout := loExpanded;
  end;
end;

procedure TMainForm.FormMouseMove(Sender: TObject; Shift: TShiftState; X, Y: Integer);
begin
  if ssLeft in Shift then
  begin
    ReleaseCapture;
    case FHitPlace of
      HTLEFT:   SendMessage(Handle, WM_SYSCOMMAND, SC_SIZE or 1, MakeLong(X, Y));
      HTRIGHT:  SendMessage(Handle, WM_SYSCOMMAND, SC_SIZE or 2, MakeLong(X, Y));
      HTTOP:    SendMessage(Handle, WM_SYSCOMMAND, SC_SIZE or 3, MakeLong(X, Y));
      HTBOTTOM: SendMessage(Handle, WM_SYSCOMMAND, SC_SIZE or 6, MakeLong(X, Y));
    else
      Exit;
    end;
    InclModify(cpForm);
  end;
end;

procedure TMainForm.FormCanResize(Sender: TObject; var NewWidth, NewHeight: Integer;
  var Resize: Boolean);
begin
  if Layout <> loCollapsed then
    case SnapEdge of
      alTop, alBottom: Resize := NewHeight > 100;
      alLeft, alRight: Resize := NewWidth > 100;
    end;
end;

procedure TMainForm.FormResize(Sender: TObject);
begin
  if NextExists then
    PostMessage(FNextWnd, AM_NOTIFY, FNChangeBounds, Handle);
end;

procedure TMainForm.TitlePanelMouseDown(Sender: TObject; Button: TMouseButton; Shift: TShiftState;
  X, Y: Integer);
begin
  SetCapture(TitlePanel.Handle);
end;

procedure TMainForm.TitlePanelMouseMove(Sender: TObject; Shift: TShiftState; X, Y: Integer);
var
  Mon: TMonitor;
  Rt: TRect;
begin
  if ssLeft in Shift then
  begin
    Mon := Screen.MonitorFromPoint(Mouse.CursorPos, mdNearest);
    Rt := Mon.WorkareaRect;
    Rt.Inflate(-25, -25);
    if Rt.Top > Mouse.CursorPos.Y then SnapEdge := alTop
    else
    if Rt.Bottom < Mouse.CursorPos.Y then SnapEdge := alBottom
    else
    if Rt.Left > Mouse.CursorPos.X then SnapEdge := alLeft
    else
    if Rt.Right < Mouse.CursorPos.X then SnapEdge := alRight;
  end;
end;

procedure TMainForm.TitlePanelMouseUp(Sender: TObject; Button: TMouseButton; Shift: TShiftState; X,
  Y: Integer);
begin
  ReleaseCapture;
end;

procedure TMainForm.OptionBtnClick(Sender: TObject);
var
  Writes: TChangeParts;
begin
  if ConfigDialog.ShowModal = mrOk then
  begin
    FModifies := [cpConfig, cpForm, cpFrame, cpTree];

    Writes := [cpConfig];
    if ConfigDialog.FromCbx.ItemIndex <> 2 then
      Include(Writes, cpForm);
    if ConfigDialog.FrameCbx.ItemIndex <> 2 then
      Include(Writes, cpFrame);
    if ConfigDialog.TreeCbx.ItemIndex <> 2 then
      Include(Writes, cpTree);

    WriteOption(Writes);
  end;
end;

procedure TMainForm.TopmostBtnClick(Sender: TObject);
begin
  Topmost := not Topmost;
end;

procedure TMainForm.PinningBtnClick(Sender: TObject);
begin
  case Layout of
    loExpanded: Layout := loPinned;
    loPinned:   Layout := loExpanded;
  end;
end;

procedure TMainForm.ExitBtnClick(Sender: TObject);
begin
  Close;
end;

procedure TMainForm.ScrollBoxDblClick(Sender: TObject);
begin
  AddDesktop;
end;

procedure TMainForm.LayoutTimerExpanding(Sender: TObject);
begin
  LayoutTimer.Enabled := False;
  //! if Assigned(FindControl(WindowFromPoint(Mouse.CursorPos))) then //Ȕ
  if BoundsRect.Contains(Mouse.CursorPos) then                        //ɂ
    Layout := loExpanded;
end;

procedure TMainForm.LayoutTimerCollapsing(Sender: TObject);
begin
  if Mouse.Capture <> TitlePanel.Handle then
  begin
    LayoutTimer.Enabled := False;
    if not BoundsRect.Contains(Mouse.CursorPos) then
      Layout := loCollapsed;
  end;
end;

procedure TMainForm.DropTargetDTDragEnter(const dataObj: IDataObject; grfKeyState: Integer;
  pt: TPoint; var dwEffect: Integer; var Result: HRESULT);
begin
  ShowFront;
  if not LayoutTimer.Enabled and (Layout = loCollapsed) then
  begin
    LayoutTimer.OnTimer := LayoutTimerExpanding;
    LayoutTimer.Enabled := True;
  end;
  FHoverPos := pt;
  HoverTimer.Enabled := True;

  Result := S_OK;
end;

procedure TMainForm.DropTargetDTDragOver(grfKeyState: Integer; pt: TPoint; var dwEffect: Integer;
  var Result: HRESULT);
var
  Ctrl: TControl;
begin
  case HitTest(pt) of
    HTCLIENT:
    begin
      Ctrl := FindDragTarget(pt, False);
      if Ctrl.Name = 'CaptionPanel' then
      begin
        HoverTimer.Enabled := FHoverPos = pt;
        FHoverPos := pt;
      end;
    end;
    HTLEFT:
    begin
      with ScrollBox.HorzScrollBar do
        if 0 < Position then
        begin
          Position := Position - Increment;
          Sleep(100);
        end;
    end;
    HTRIGHT:
    begin
      with ScrollBox.HorzScrollBar do
        if Position < Range then
        begin
          Position := Position + Increment;
          Sleep(100);
        end;
    end;
    HTTOP:
    begin
      with ScrollBox.VertScrollBar do
        if 0 < Position then
        begin
          Position := Position - Increment;
          Sleep(100);
        end;
    end;
    HTBOTTOM:
    begin
      with ScrollBox.VertScrollBar do
        if Position < Range then
        begin
          Position := Position + Increment;
          Sleep(100);
        end;
    end;
  end;
  Result := S_OK;
end;

procedure TMainForm.DropTargetDTDragLeave(var Result: HRESULT);
begin
  if not LayoutTimer.Enabled and (Layout = loExpanded) then
  begin
    LayoutTimer.OnTimer := LayoutTimerCollapsing;
    LayoutTimer.Enabled := True;
  end;
  HoverTimer.Enabled := False;
  Result := S_OK;
end;

procedure TMainForm.DropTargetDTDrop(const dataObj: IDataObject; grfKeyState: Integer; pt: TPoint;
  var dwEffect: Integer; var Result: HRESULT);
var
  NewFrame: TNavFrame;
  Count, i: Integer;
  Stg: TStgMedium;
  FileName: array[0..MAX_PATH] of Char;
  Ctrl: TControl;
begin
  HoverTimer.Enabled := False;

  if Succeeded(dataObj.GetData(GenledClipFmt(CF_HDROP, -1, TYMED_HGLOBAL), Stg)) then
  begin
    NewFrame := AddFrame;
    Count := DragQueryFile(Stg.hGlobal, $FFFFFFFF, nil, 0);
    try
      for i := 0 to Count - 1 do
      begin
        DragQueryFile(Stg.hGlobal, i, FileName, SizeOf(FileName));
        AddRoot(NewFrame, FileName);
      end;
    finally
      DragFinish(Stg.hGlobal);
    end;

    Ctrl := FindDragTarget(pt, False);
    if Ctrl.Name = 'CaptionPanel' then
    begin
      MoveFrame(NewFrame, TNavFrame(Ctrl.Owner));
    end;
  end;
  Result := S_OK;
end;

procedure TMainForm.HoverTimerTimeOut(Sender: TObject);
var
  Ctrl: TControl;
begin
  HoverTimer.Enabled := False;

  Ctrl := FindDragTarget(FHoverPos, False);
  if Ctrl.Name = 'CaptionPanel' then
    TNavFrame(Ctrl.Owner).Collapsed := False;
end;

procedure TMainForm.SplitterCanResize(Sender: TObject; var NewSize: Integer; var Accept: Boolean);
var
  i: Integer;
begin
  i := FFrames.IndexOf(Sender) - 1;
  if TObject(FFrames.Items[i]) is TNavFrame then
    Accept := not TNavFrame(FFrames.Items[i]).Collapsed;

  if Accept then
  begin
    case SnapEdge of
      alTop, alBottom: Accept := NewSize > 50;
      alLeft, alRight: Accept := NewSize > 50;
    end;
    InclModify(cpFrame);
  end;
end;

initialization
  FrameCounter := TBits.Create;
  XMLFileName := AppDataName('ShaggyDog\Filerac\' + ChangeFileExt(ExtractFileName(ParamStr(0)), '.xml'));

finalization
  FrameCounter.Free;

end.
