unit FILAC_Nav;

interface

uses
  Winapi.Windows, Winapi.Messages, System.SysUtils, System.Variants, System.Classes, Vcl.Graphics,
  Vcl.Controls, Vcl.Forms, Vcl.Dialogs, Vcl.AppEvnts, System.ImageList, Vcl.ImgList, Vcl.ExtCtrls,
  Vcl.Buttons, Winapi.ShlObj, Winapi.ActiveX, ShellTypes, VistaShellCtrls, Vcl.Menus;

type
  TPanel = class(Vcl.ExtCtrls.TPanel)
  protected
    { protected 錾 }
    procedure Paint; override;
  end;

  TPopupMenu = class(Vcl.Menus.TPopupMenu, IContextMenu)
  protected
    { protected 錾 }
    //IContextMenu
    function QueryContextMenu(Menu: HMENU;
      indexMenu, idCmdFirst, idCmdLast, uFlags: UINT): HResult; stdcall;
    function InvokeCommand(var lpici: TCMInvokeCommandInfo): HResult; stdcall;
    function GetCommandString(idCmd: UINT_PTR; uFlags: UINT; pwReserved: PUINT;
      pszName: LPSTR; cchMax: UINT): HResult; stdcall;
  end;

  TNavFrame = class(TFrame)
    AppNavEvents: TApplicationEvents;
    CaptionImages: TImageList;
    CaptionPanel: TPanel;
    PreferenceBtn: TSpeedButton;
    PreferenceMenu: TPopupMenu;
    HasLinesMnu: TMenuItem;
    FullRowSelectMnu: TMenuItem;
    SpringExpandMnu: TMenuItem;
    HorizontalScrollMnu: TMenuItem;
    ShowSelectionAlwaysMnu: TMenuItem;
    NoEditLabelsMnu: TMenuItem;
    AutoHScrollMnu: TMenuItem;
    FadeInOutExpandosMnu: TMenuItem;
    SwitchingBtn: TSpeedButton;
    CloseBtn: TSpeedButton;
    NameSpaceTree: TNameSpaceTreeControl;
    ContextMenu: TPopupMenu;
    NewFrameMnu: TMenuItem;
    NewRootMnu: TMenuItem;
    OpenMnu: TMenuItem;
    OpenTargetMnu: TMenuItem;
    RootFiltersMnu: TMenuItem;
    FoldersMnu: TMenuItem;
    NonFoldersMnu: TMenuItem;
    IncludeHiddenMnu: TMenuItem;
    IncludeSuperHiddenMnu: TMenuItem;
    RemoveRootMnu: TMenuItem;
    procedure AppNavEventsIdleAtCreate(Sender: TObject; var Done: Boolean);
    procedure AppNavEventsIdleAtRestore(Sender: TObject; var Done: Boolean);
    procedure FrameExit(Sender: TObject);
    procedure CaptionPanelClick(Sender: TObject);
    procedure CaptionPanelMouseDown(Sender: TObject; Button: TMouseButton; Shift: TShiftState; X,
      Y: Integer);
    procedure CaptionPanelDragOver(Sender, Source: TObject; X, Y: Integer; State: TDragState;
      var Accept: Boolean);
    procedure CaptionPanelDragDrop(Sender, Source: TObject; X, Y: Integer);
    procedure PreferenceBtnClick(Sender: TObject);
    procedure PreferenceMenuPopup(Sender: TObject);
    procedure PreferenceMnusClick(Sender: TObject);
    procedure SwitchingBtnClick(Sender: TObject);
    procedure CloseBtnClick(Sender: TObject);
    procedure NameSpaceTreeViewWndProc(var Message: TMessage);
    procedure NameSpaceTreeNTEOnSelectionChanged(const psiaSelection: IShellItemArray;
      var Result: HRESULT);
    procedure NameSpaceTreeNTEOnAfterExpand(const psi: IShellItem; var Result: HRESULT);
    procedure NameSpaceTreeNTDHOnDragPosition(const psiOver: IShellItem;
      const psiaData: IShellItemArray; iNewPosition, iOldPosition: Integer; var Result: HRESULT);
    procedure NameSpaceTreeNTDHOnDrop(const psiOver: IShellItem; const psiaData: IShellItemArray;
      iPosition: Integer; grfKeyState: Cardinal; var pdwEffect: Cardinal; var Result: HRESULT);
    procedure NameSpaceTreeNTEOnBeforeContextMenu(const psi: IShellItem; const riid: TGUID; out ppv;
      var Result: HRESULT);
    procedure NewFrameMnuClick(Sender: TObject);
    procedure NewRootMnuClick(Sender: TObject);
    procedure OpenTargetMnuClick(Sender: TObject);
    procedure OpenMnuClick(Sender: TObject);
    procedure RootFilterMnusClick(Sender: TObject);
    procedure RemoveRootMnuClick(Sender: TObject);
  private
    { Private 錾 }
    FID: Integer;
    FHitPlace: NativeInt;
    FExpandWidth,
    FExpandHeight: Integer;
    FChoices: IShellItemArray;
    procedure RedrawGlyph(Button: TSpeedButton);
    function GetAlign: TAlign;
    procedure SetAlign(Value: TAlign);
    function GetCollapsed: Boolean;
    procedure SetCollapsed(Value: Boolean);
    procedure SetExpandWidth(Value: Integer);
    procedure SetExpandHeight(Value: Integer);
    function GetSelected: IShellItem;
    procedure CMColorChanged(var Message: TMessage); message CM_COLORCHANGED;
  public
    { Public 錾 }
    ExpandingReserves,
    MarkingReserves: TStrings;
    constructor Create(AOwner: TComponent; AID: Integer); reintroduce;
    destructor Destroy; override;
    function TrackRoot(Item: IShellItem): IShellItem;
    function RootAs(Item: IShellItem): TNamespaceTreeRoot;
    procedure StoreReserves(First, Select, Focus: IShellItem);
    procedure RestoreReserves;
    procedure Reload(Select: IShellItem);
    property ID: Integer read FID;
    property Align: TAlign read GetAlign write SetAlign;
    property Collapsed: Boolean read GetCollapsed write SetCollapsed;
    property ExpandWidth: Integer read FExpandWidth write SetExpandWidth;
    property ExpandHeight: Integer read FExpandHeight write SetExpandHeight;
    property Selected: IShellItem read GetSelected;
  end;

implementation

{$R *.dfm}

uses
  FILAC_Main,
  System.Types, System.UITypes, Vcl.FileCtrl, AppData, System.Win.ComObj, ShellUtils, ShellLink;

resourcestring
  SExpand = 'WJ';
  SCollapse = '܂';
  STargetNotFound = 'N悪܂';
  STargetNotExist = 'N悪c[ɑ݂܂';
  SFailedParseTarget = 'N̉͂Ɏs܂';

{ Routine }

{ cLvVΉ TPanel }

procedure TPanel.Paint;
var
  MaxLen, x, y: Integer;
  s: string;
begin
  inherited;

  if not ShowCaption and (Caption <> '') then
  begin
    Canvas.Font.Assign(Font);
    Canvas.Brush.Style := bsClear;
    case Align of
      alTop, alBottom:
      begin
        MaxLen := Width - 67;
        x := 28;
        y := (25 - Canvas.TextHeight(Caption)) div 2;
      end;
      alLeft, alRight:
      begin
        MaxLen := Height - 67;
        x := (25 - Canvas.TextHeight(Caption)) div 2;
        y := BoundsRect.Bottom - 28;
      end;
    else
      MaxLen := Canvas.TextWidth(Caption);
      x := 0;
      y := 0;
    end;
    s := MinimizeName(Caption, Canvas, MaxLen);
    while MaxLen < Canvas.TextWidth(s) do
      Delete(s, High(s), 1);

    if IsDark(Color) then
      Canvas.Font.Color := clWhite
    else
      Canvas.Font.Color := clBlack;
    Canvas.TextOut(x, y, s);
  end;
end;

{ IContextMenu ǉ TPopupMenu }

const
  IdCmdMin = 1;
  IdCmdMax = 30000;

function MAKE_SCODE(sev, fac, code: DWORD): DWORD;
begin
  Result := DWORD((sev shl 31) or (fac shl 16) or code);
end;

function FindUnusedId(Menu: HMENU; First, Last: UINT; var Unused: UINT): Boolean;
var
  i: UINT;
  Info: TMenuItemInfo;
begin
  Result := False;
  for i := First to Last do
  begin
    //! FillChar(Info, SizeOf(TMenuItemInfo), #0);
    Info.cbSize := SizeOf(TMenuItemInfo);
    Info.fMask := MIIM_ID;
    GetMenuItemInfo(Menu, i, False, Info);
    Result := GetLastError = ERROR_MENU_ITEM_NOT_FOUND;
    if Result then
    begin
      Unused := i;
      Exit;
    end;
  end;
end;

function TPopupMenu.QueryContextMenu(Menu: HMENU;
  indexMenu, idCmdFirst, idCmdLast, uFlags: UINT): HResult;
var
  ID: UINT;
  i: Integer;
  Flags: UINT;
  Info: TMenuItemInfo;
begin
  if (uFlags and CMF_DEFAULTONLY) <> 0 then
    Result := MAKE_SCODE(SEVERITY_SUCCESS, FACILITY_NULL, 0)
  else
  begin
    if FindUnusedId(Menu, idCmdFirst, idCmdLast, ID) then
      InsertMenu(Menu, 0, MF_STRING or MF_BYPOSITION, ID, PChar(Items.Items[0].Caption));
    if FindUnusedId(Menu, ID + 1, idCmdLast, ID) then
      InsertMenu(Menu, 1, MF_STRING or MF_BYPOSITION, ID, PChar(Items.Items[1].Caption));
    InsertMenu(Menu, 2, MF_SEPARATOR or MF_BYPOSITION, 0, nil);
    //open ftHgɂłȂ݂Bexpand ftHgŒH
    if FindUnusedId(Menu, ID + 1, idCmdLast, ID) then
      InsertMenu(Menu, 3, MF_STRING or MF_BYPOSITION, ID, PChar(Items.Items[2].Caption));
    if Items.Items[3].Visible and FindUnusedId(Menu, ID + 1, idCmdLast, ID) then
      InsertMenu(Menu, 4, MF_STRING or MF_BYPOSITION, ID, PChar(Items.Items[3].Caption));
    if FindUnusedId(Menu, ID + 1, idCmdLast, ID) then
    begin
      with Info do
      begin
        cbSize :=Sizeof(TMenuItemInfo);
        fMask := MIIM_ID or MIIM_TYPE or MIIM_SUBMENU;
        ftype := MFT_STRING;
        wID := ID;
        hSubMenu := CreateMenu;
        dwtypeData := PChar(Items.Items[4].Caption);
        cch := Length(Items.Items[4].Caption);
      end;
      if InsertMenuItem(Menu, GetMenuItemCount(Menu), True, Info) then
      begin
        for i := 0 to Items.Items[4].Count - 1 do
        begin
          if FindUnusedId(Menu, ID + 1, idCmdLast, ID) then
          begin
            Flags := MF_STRING;
            if Items.Items[4].Items[i].Checked then
              Flags := Flags or MF_CHECKED;
            AppendMenu(Info.hSubMenu, Flags, ID, PChar(Items.Items[4].Items[i].Caption));
          end;
        end;
      end;
    end;
    if Items.Items[5].Enabled and FindUnusedId(Menu, ID + 1, idCmdLast, ID) then
      AppendMenu(Menu, MF_STRING, ID, PChar(Items.Items[5].Caption));

    Result := MAKE_SCODE(SEVERITY_SUCCESS, FACILITY_NULL, GetMenuItemCount(Menu));
  end;
end;

function TPopupMenu.InvokeCommand(var lpici: TCMInvokeCommandInfo): HResult;
var
  Count: Word;
  i: Integer;
begin
  if HiWord(Integer(lpici.lpVerb)) = 0 then
  begin
    Count := LoWord(Integer(lpici.lpVerb)) + 1;
    for i := 0 to 9 do
    begin
      case i of
        0..4: if Items.Items[i].Visible then Dec(Count);
        5..8: if Items.Items[4].Items[i - 5].Visible then Dec(Count);
        9:    if Items.Items[5].Visible then Dec(Count);
      end;
      if Count = 0 then
      begin
        case i of
          0..3: Items.Items[i].Click;
          5..8: Items.Items[4].Items[i - 5].Click;
          9:    Items.Items[5].Click;
        end;
        Break;
      end;
    end;
    Result := S_OK;
  end
  else
    Result := E_INVALIDARG;
end;

function TPopupMenu.GetCommandString(idCmd: UINT_PTR; uFlags: UINT; pwReserved: PUINT;
  pszName: LPSTR; cchMax: UINT): HResult;
begin
  Result := E_NOTIMPL;
end;

{ TNavFrame }

procedure TNavFrame.RedrawGlyph(Button: TSpeedButton);
var
  Bmp: TBitmap;
begin
  if Assigned(CaptionImages) then
  begin
    Bmp := TBitmap.Create;
    try
      Bmp.PixelFormat := pf4bit;
      CaptionImages.GetBitmap(Button.Tag, Bmp);
      Button.Glyph.Assign(Bmp);

      if IsDark(Color) then
      begin
        Button.Glyph.Canvas.CopyMode := cmDstInvert;
        Button.Glyph.Canvas.CopyRect(Rect(0, 0, 16, 16), Bmp.Canvas, Rect(0, 0, 16, 16));
      end;
    finally
      Bmp.Free;
    end;
  end;
end;

function TNavFrame.GetAlign: TAlign;
begin
  Result := inherited Align;
end;

procedure TNavFrame.SetAlign(Value: TAlign);
begin
  inherited Align := Value;

  case Align of
    alTop:
    begin
      CaptionPanel.Align := alTop;
      CloseBtn.Align := alRight;
      SwitchingBtn.Align := alRight;
      SwitchingBtn.Left := CloseBtn.Left - SwitchingBtn.Width - 1;
      CaptionPanel.Font.Orientation := 0;
      PreferenceBtn.Align := alLeft;
    end;
    alLeft:
    begin
      CaptionPanel.Align := alLeft;
      CloseBtn.Align := alTop;
      SwitchingBtn.Align := alTop;
      SwitchingBtn.Top :=CloseBtn.BoundsRect.Bottom + 1;
      CaptionPanel.Font.Orientation := 900;
      PreferenceBtn.Align := alBottom;
    end;
  end;
  Realign;
end;

function TNavFrame.GetCollapsed: Boolean;
begin
  Result := SwitchingBtn.Tag = 2;
end;

procedure TNavFrame.SetCollapsed(Value: Boolean);
var
  NewTag: NativeInt;
begin
  if Value then
    NewTag := 2
  else
    NewTag := 1;
  if NewTag <> SwitchingBtn.Tag then
  begin
    SwitchingBtn.Tag := NewTag;
    RedrawGlyph(SwitchingBtn);

    if Collapsed then
    begin
      case Align of
        alTop:
        begin
          FExpandHeight := Height;
          Height := CaptionPanel.Height;
        end;
        alLeft:
        begin
          FExpandWidth := Width;
          Width := CaptionPanel.Width;
        end;
      end;
      SwitchingBtn.Hint := SExpand;
    end
    else
    begin
      case Align of
        alTop: Height := FExpandHeight;
        alLeft: Width := FExpandWidth;
      end;
      SwitchingBtn.Hint := SCollapse;
    end;
    Realign;
    TMainForm(Owner).InclModify(cpFrame);
  end;
end;

procedure TNavFrame.SetExpandWidth(Value: Integer);
begin
  if Value <> FExpandWidth then
  begin
    FExpandWidth := Value;
    if not Collapsed then
      Width := FExpandWidth;
    TMainForm(Owner).InclModify(cpFrame);
  end;
end;

procedure TNavFrame.SetExpandHeight(Value: Integer);
begin
  if Value <> FExpandHeight then
  begin
    FExpandHeight := Value;
    if not Collapsed then
      Height := FExpandHeight;
    TMainForm(Owner).InclModify(cpFrame);
  end;
end;

function TNavFrame.GetSelected: IShellItem;
var
  Items: IShellItemArray;
begin
  if Succeeded(NameSpaceTree.GetSelectedItems(Items)) and Assigned(Items) then
    Items.GetItemAt(0, Result)
  else
    Result := nil;
end;


procedure TNavFrame.CMColorChanged(var Message: TMessage);
begin
  inherited;

  RedrawGlyph(PreferenceBtn);
  RedrawGlyph(SwitchingBtn);
  RedrawGlyph(CloseBtn);
end;

function TNavFrame.TrackRoot(Item: IShellItem): IShellItem;
var
  ParentItem: IShellItem;
begin
  ParentItem := Item;
  repeat
    Result := ParentItem;
  until Failed(NameSpaceTree.GetNextItem(Result, NSTCGNI_PARENT, ParentItem));
end;

function TNavFrame.RootAs(Item: IShellItem): TNamespaceTreeRoot;
var
  i, Order: Integer;
begin
  Result := nil;

  if Assigned(Item) then
  begin
    for i := 0 to NameSpaceTree.Roots.Count - 1 do
      if NameSpaceTree.Roots.Items[i].SHItem.Compare(Item, SICHINT_ALLFIELDS, Order) = S_OK then
      begin
        Result := NameSpaceTree.Roots.Items[i];
        Break;
      end;
  end;
end;

procedure TNavFrame.StoreReserves(First, Select, Focus: IShellItem);
var
  State: NSTCITEMSTATE;
  CurrentItem, NextItem: IShellItem;
begin
  AppNavEvents.OnIdle := nil;
  ExpandingReserves.Clear;
  MarkingReserves.Clear;

  if Assigned(First) then
  begin
    NextItem := First;
    repeat
      CurrentItem := NextItem;
      NameSpaceTree.GetItemState(CurrentItem, NSTCIS_EXPANDED, State);
      if State and NSTCIS_EXPANDED <> 0 then
        ExpandingReserves.Add(GetVerbosePath(CurrentItem));
    until Failed(NameSpaceTree.GetNextItem(CurrentItem, NSTCGNI_NEXTVISIBLE, NextItem));
  end;
  if Assigned(Select) then
    MarkingReserves.Add(GetVerbosePath(Select));
  if Assigned(Focus) then
    MarkingReserves.Add(GetVerbosePath(Focus));
end;

procedure TNavFrame.RestoreReserves;
var
  Item: IShellItem;

  function ExtractReserve(List: TStrings): IShellItem;
  var
    Path: string;
  begin
    Path := List.Strings[0];
    List.Delete(0);
    ParseVerbosePath(Application.Handle, Path, Result);
  end;

begin
  //CɏƍXVԂɍ킸A\Ȃ̂ Application.OnIdle ňB
  if not Assigned(AppNavEvents.OnIdle)
    and ((ExpandingReserves.Count > 0) or (MarkingReserves.Count > 0)) then
  begin
    AppNavEvents.OnIdle := AppNavEventsIdleAtRestore;
    Exit;
  end;

  if ExpandingReserves.Count > 0 then
  begin
    Item := ExtractReserve(ExpandingReserves);
    if Assigned(Item) then
      NameSpaceTree.SetItemState(Item, NSTCIS_EXPANDED, NSTCIS_EXPANDED);
  end
  else if MarkingReserves.Count > 0 then
  begin
    Item := ExtractReserve(MarkingReserves);
    if Assigned(Item) then
    begin
      if MarkingReserves.Count > 0 then
        NameSpaceTree.SetItemState(Item, NSTCIS_SELECTED, NSTCIS_SELECTED);
      NameSpaceTree.EnsureItemVisible(Item);
    end;
  end
  else
  begin
    AppNavEvents.OnIdle := nil;
    TMainForm(Owner).ExclModify(cpTree);
  end;
end;

procedure TNavFrame.Reload(Select: IShellItem);
var
  RootItem: IShellItem;
  TreeRoot: TNamespaceTreeRoot;
begin
  if Assigned(Select) then
  begin
    RootItem := TrackRoot(Select);
    TreeRoot := RootAs(RootItem);
    if Assigned(TreeRoot) then
    begin
      StoreReserves(RootItem, Select, Select);
      try
        TreeRoot.Reload;
      finally
        RestoreReserves;
      end;
    end;
  end;
end;

procedure TNavFrame.AppNavEventsIdleAtCreate(Sender: TObject; var Done: Boolean);
var
  RegFile: TXMLRegFile;
  TreePath, RootPath: string;
  Roots, Folders: TStrings;
  i, ActiveFrame: Integer;
begin
  if NameSpaceTree.Actuated then
    AppNavEvents.OnIdle := nil
  else
    Exit;

  RegFile := TXMLRegFile.Create(XMLFileName);
  try
    if RegFile.OpenNode('\Snapshot', True) then
    begin
      ActiveFrame := RegFile.ReadIntDef('ActiveFrame', 0);
      if ActiveFrame = ID then
        NameSpaceTree.SetFocus;
    end;
    TreePath := Format('\Snapshot\Frames\Id.%d\Tree', [ID]);
    if RegFile.OpenNode(TreePath + '\Roots', True) then
    begin
      Roots := TStringList.Create;
      try
        RegFile.GetNodeNames(Roots);
        for i := 0 to Roots.Count - 1 do
        begin
          RootPath := TreePath + '\Roots\' + Roots.Strings[i];
          if RegFile.OpenNode(RootPath, True) then
          begin
            Folders := TStringList.Create;
            try
              Folders.CommaText := RegFile.ReadStrDef('Expands', '');
              ExpandingReserves.AddStrings(Folders);
            finally
              Folders.Free;
            end;
            if RegFile.ValueExists('Selected') then
            begin
              MarkingReserves.Add(RegFile.ReadString('Selected'));
              MarkingReserves.Add(RegFile.ReadString('Selected'));
            end;
          end;
        end;
      finally
        Roots.Free;
      end;
    end;
  finally
    RegFile.Free;
  end;
  RestoreReserves;
end;

procedure TNavFrame.AppNavEventsIdleAtRestore(Sender: TObject; var Done: Boolean);
begin
  RestoreReserves;
end;

constructor TNavFrame.Create(AOwner: TComponent; AID: Integer);
begin
  inherited Create(AOwner);

  FID := AID;
  FHitPlace := HTCLIENT;
  FExpandWidth := LeastWidht;
  FExpandHeight := LeastHeight;
  FChoices := nil;
  ExpandingReserves := TStringList.Create;
  MarkingReserves := TStringList.Create;
end;

destructor TNavFrame.Destroy;
begin
  ExpandingReserves.Free;
  MarkingReserves.Free;

  inherited;
end;

procedure TNavFrame.FrameExit(Sender: TObject);
begin
  TMainForm(Owner).InclModify(cpFrame);
end;

procedure TNavFrame.CaptionPanelClick(Sender: TObject);
begin
  NameSpaceTree.SetFocus;
end;

procedure TNavFrame.CaptionPanelMouseDown(Sender: TObject; Button: TMouseButton; Shift: TShiftState;
  X, Y: Integer);
begin
  if Button = mbLeft then
    TPanel(Sender).BeginDrag(False);
end;

procedure TNavFrame.CaptionPanelDragOver(Sender, Source: TObject; X, Y: Integer; State: TDragState;
  var Accept: Boolean);
begin
  Accept := Sender <> Source;
end;

procedure TNavFrame.CaptionPanelDragDrop(Sender, Source: TObject; X, Y: Integer);
var
  CurFrame, NewFrame: TNavFrame;
begin
  CurFrame := TPanel(Source).Owner as TNavFrame;
  NewFrame := TPanel(Sender).Owner as TNavFrame;
  TMainForm(Owner).MoveFrame(CurFrame, NewFrame);
end;

procedure TNavFrame.PreferenceBtnClick(Sender: TObject);
begin
  PreferenceMenu.Popup(Mouse.CursorPos.X, Mouse.CursorPos.Y);
end;

procedure TNavFrame.PreferenceMenuPopup(Sender: TObject);
begin
  HasLinesMnu.Checked := nstcsHasLines in NameSpaceTree.Styles;
  FullRowSelectMnu.Checked := nstcsFullRowSelect in NameSpaceTree.Styles;
  SpringExpandMnu.Checked := nstcsSpringExpand in NameSpaceTree.Styles;
  HorizontalScrollMnu.Checked := nstcsHorizontalScroll in NameSpaceTree.Styles;
  ShowSelectionAlwaysMnu.Checked := nstcsShowSelectionAlways in NameSpaceTree.Styles;
  NoEditLabelsMnu.Checked := nstcsNoEditLabels in NameSpaceTree.Styles;
  AutoHScrollMnu.Checked := nstcsAutoHScroll in NameSpaceTree.Styles;
  FadeInOutExpandosMnu.Checked := nstcsFadeInOutExpandos in NameSpaceTree.Styles;
end;

procedure TNavFrame.PreferenceMnusClick(Sender: TObject);
var
  NewStyles: TNamespaceTreeControlStyles;
  Style: TNamespaceTreeControlStyle;
begin
  NewStyles := NameSpaceTree.Styles;
  with TMenuItem(Sender) do
  begin
    Style := TNamespaceTreeControlStyle(Tag);
    if Checked then
    begin
      Include(NewStyles, Style);
      case Style of
        nstcsHasLines: Exclude(NewStyles, nstcsFullRowSelect);
        nstcsFullRowSelect: Exclude(NewStyles, nstcsHasLines);
      end;
    end
    else
      Exclude(NewStyles, Style);
  end;
  NameSpaceTree.Styles := NewStyles;
  TMainForm(Owner).InclModify(cpFrame);
end;

procedure TNavFrame.SwitchingBtnClick(Sender: TObject);
begin
  Collapsed := not Collapsed;
end;

procedure TNavFrame.CloseBtnClick(Sender: TObject);
begin
  TMainForm(Owner).DelFrame(Self);
end;

procedure TNavFrame.NameSpaceTreeViewWndProc(var Message: TMessage);
var
  Item: IShellItem;
  Attr: DWORD;
begin
  if (Message.Msg = WM_LBUTTONDBLCLK)
    or ((Message.Msg = WM_KEYDOWN) and (Message.WParam = VK_RETURN)) then
  begin
    Item := Selected;
    if Assigned(Item) then
    begin
      //ktH_ SFGAO_FOLDER or SFGAO_STREAM 炵B
      if Failed(Item.GetAttributes(SFGAO_FOLDER or SFGAO_STREAM, Attr)) then Attr := 0;
      if Attr <> SFGAO_FOLDER then
      begin
        SHCreateShellItemArrayFromShellItem(Item, IID_IShellItemArray, Pointer(FChoices));
        OpenMnu.Click;
      end;
    end;
  end
  else if (Message.Msg = WM_KEYDOWN) and (Message.WParam = VK_F5) then
  begin
    Reload(Selected);
  end;
end;

procedure TNavFrame.NameSpaceTreeNTEOnSelectionChanged(const psiaSelection: IShellItemArray;
  var Result: HRESULT);
var
  Item: IShellItem;
begin
  psiaSelection.GetItemAt(0, Item);
  CaptionPanel.Caption := GetDisplayName(Item, SIGDN_DESKTOPABSOLUTEEDITING);
  TMainForm(Owner).InclModify(cpTree);
  Result := S_OK;
end;

procedure TNavFrame.NameSpaceTreeNTEOnAfterExpand(const psi: IShellItem; var Result: HRESULT);
begin
  TMainForm(Owner).InclModify(cpTree);
  Result := E_NOTIMPL;
end;

procedure TNavFrame.NameSpaceTreeNTDHOnDragPosition(const psiOver: IShellItem;
  const psiaData: IShellItemArray; iNewPosition, iOldPosition: Integer; var Result: HRESULT);
const
  Delay = 50;
begin
  FChoices := psiaData;
  case NameSpaceTree.ScrollIn(Mouse.CursorPos) of
    dtLeft..dtDown: Sleep(Delay);
  end;
  Result := S_OK;
end;

procedure TNavFrame.NameSpaceTreeNTDHOnDrop(const psiOver: IShellItem;
  const psiaData: IShellItemArray; iPosition: Integer; grfKeyState: Cardinal;
  var pdwEffect: Cardinal; var Result: HRESULT);
var
  Count, i: Cardinal;
  Item: IShellItem;
begin
  if not Assigned(psiOver) then
  begin
    FChoices.GetCount(Count);
    for i := 0 to Count - 1 do
    begin
      FChoices.GetItemAt(i, Item);
      TMainForm(Owner).AddRoot(Self, RootSHName(Item));
    end;

    Result := E_NOTIMPL;
  end
  else
    Result := S_OK;
end;

procedure TNavFrame.NameSpaceTreeNTEOnBeforeContextMenu(const psi: IShellItem; const riid: TGUID;
  out ppv; var Result: HRESULT);
var
  Attr: DWORD;
  Root: TNamespaceTreeRoot;
  ParentItem: IShellItem;
begin
  if Assigned(psi) and Succeeded(ContextMenu.QueryInterface(riid, ppv)) then
  begin
    SHCreateShellItemArrayFromShellItem(psi, IID_IShellItemArray, Pointer(FChoices));

    if Failed(psi.GetAttributes(SFGAO_LINK, Attr)) then Attr := 0;
    OpenTargetMnu.Visible := Attr = SFGAO_LINK;

    Root := RootAs(TrackRoot(psi));
    if Assigned(Root) then
    begin
      FoldersMnu.Checked := shcontfFolders in Root.Filters;
      NonFoldersMnu.Checked := shcontfNonFolders in Root.Filters;
      IncludeHiddenMnu.Checked := shcontfIncludeHidden in Root.Filters;
      IncludeSuperHiddenMnu.Checked := shcontfIncludeSuperHidden in Root.Filters;
    end;
    RemoveRootMnu.Enabled := Failed(NameSpaceTree.GetNextItem(psi, NSTCGNI_PARENT, ParentItem));

    Result := S_OK;
  end
  else
    Result := E_NOTIMPL;
end;

procedure TNavFrame.NewFrameMnuClick(Sender: TObject);
var
  Item: IShellItem;
  NewFrame: TNavFrame;
  NewRoot: TNamespaceTreeRoot;
  i: Integer;
begin
  FChoices.GetItemAt(0, Item);
  with TMainForm(Owner) do
  begin
    NewFrame := AddFrame;
    NewRoot := AddRoot(NewFrame, RootSHName(Item));
    case SnapEdge of
      alTop, alBottom:
      begin
        i := ScrollBox.HorzScrollBar.Range;
        if i > ScrollBox.Width then
        begin
          Inc(i, ScrollBox.HorzScrollBar.Position);
          ScrollBox.HorzScrollBar.Position := i;
        end;
      end;
      alLeft, alRight:
      begin
        i := ScrollBox.VertScrollBar.Range;
        if i > ScrollBox.Height then
        begin
          Inc(i, ScrollBox.VertScrollBar.Position);
          ScrollBox.VertScrollBar.Position := i;
        end;
      end;
    end;
  end;
  with NewFrame.NameSpaceTree do
  begin
    SetFocus;
    SetItemState(NewRoot.SHItem, NSTCIS_SELECTED, NSTCIS_SELECTED);
  end;
end;

procedure TNavFrame.NewRootMnuClick(Sender: TObject);
var
  Item: IShellItem;
  NewRoot: TNamespaceTreeRoot;
begin
  FChoices.GetItemAt(0, Item);
  NewRoot := TMainForm(Owner).AddRoot(Self, RootSHName(Item));
  with NameSpaceTree do
  begin
    EnsureItemVisible(NewRoot.SHItem);
    SetItemState(NewRoot.SHItem, NSTCIS_SELECTED, NSTCIS_SELECTED);
  end;
end;

procedure TNavFrame.OpenTargetMnuClick(Sender: TObject);
var
  FocusItem, TargetItem, RootItem, ParentItem: IShellItem;
  FocusPath, TargetPath: string;
  PIDL: PItemIDList;
  HR: HRESULT;
  Exist: Boolean;
begin
  FChoices.GetItemAt(0, FocusItem);
  FocusPath := GetDisplayName(FocusItem, SHGDN_FORPARSING);
  if not GetLinkTarget(FocusPath, PIDL) then
    if not GetSymlinkTarget(FocusPath, PIDL) then
    begin
      MessageDlg(STargetNotFound, mtError, [mbOk], 0);
      Exit;
    end;
  try
    HR := SHCreateShellItem(nil, nil, PIDL, TargetItem);
  finally
    DisposePIDL(PIDL);
  end;

  if Succeeded(HR) then
  begin
    TargetPath := GetVerbosePath(TargetItem);
    RootItem := TrackRoot(FocusItem);
    if SameSHItem(RootItem, DesktopSHItem) then
      Exist := True  //fXNgbvȂɐ^B
    else
      Exist := Pos(GetVerbosePath(RootItem), TargetPath) = 1;

    if Exist then
    begin
      AppNavEvents.OnIdle := nil;
      ExpandingReserves.Clear;
      MarkingReserves.Clear;

      if Assigned(TargetItem) then
      begin
        ExpandingReserves.Add(GetVerbosePath(RootItem));

        ParentItem := TargetItem;
        while not SameSHItem(RootItem, ParentItem) do
        begin
          ExpandingReserves.Insert(1, GetVerbosePath(ParentItem));
          if Failed(ParentItem.GetParent(ParentItem)) then
          begin
            ExpandingReserves.Clear;
            Break;
          end;
        end;
        if ExpandingReserves.Count > 0 then
        begin
          MarkingReserves.Add(TargetPath);
          MarkingReserves.Add(TargetPath);

          RestoreReserves;
        end
        else
          MessageDlg(SFailedParseTarget, mtError, [mbOk], 0);
      end;
    end
    else
      MessageDlg(STargetNotExist, mtError, [mbOk], 0);
  end
  else
    MessageDlg(SysErrorMessage(HR), mtError, [mbOk], 0);
end;

procedure TNavFrame.OpenMnuClick(Sender: TObject);
var
  Item: IShellItem;
  ContextMenu: IContextMenu;
  PopupMenu: HMenu;
  Info: TCMInvokeCommandInfo;
begin
  FChoices.GetItemAt(0, Item);
  Item.BindToHandler(nil, BHID_SFUIObject, IID_IContextMenu, ContextMenu);
  if Assigned(ContextMenu) then
  begin
    PopupMenu := CreatePopupMenu;
    try
      ContextMenu.QueryContextMenu(PopupMenu, 0, 1, $7FFF, CMF_EXPLORE);

      FillChar(Info, SizeOf(Info), #0);
      with Info do
      begin
        cbSize := SizeOf(Info);
        hWND := Handle;
        lpVerb := 'open';
        nShow := SW_SHOWNORMAL;
      end;
      ContextMenu.InvokeCommand(Info);
    finally
      DestroyMenu(PopupMenu);
    end;
  end;
end;

procedure TNavFrame.RootFilterMnusClick(Sender: TObject);
var
  FocusItem, RootItem: IShellItem;
  TreeRoot: TNamespaceTreeRoot;
  NewFilters: TShellContactFilters;
  Filter: TShellContactFilter;
begin
  FChoices.GetItemAt(0, FocusItem);
  RootItem := TrackRoot(FocusItem);
  TreeRoot := RootAs(RootItem);
  if Assigned(TreeRoot) then
  begin
    StoreReserves(RootItem, Selected, FocusItem);

    NewFilters := TreeRoot.Filters;
    with TMenuItem(Sender) do
    begin
      Filter := TShellContactFilter(Tag);
      if Checked then
        Include(NewFilters, Filter)
      else
        Exclude(NewFilters, Filter);
    end;
    TreeRoot.Filters := NewFilters;

    RestoreReserves;
    TMainForm(Owner).InclModify(cpFrame);
  end;
end;

procedure TNavFrame.RemoveRootMnuClick(Sender: TObject);
var
  Item: IShellItem;
  Root: TNamespaceTreeRoot;
begin
  FChoices.GetItemAt(0, Item);
  Root := RootAs(Item);
  if Assigned(Root) then
  begin
    NameSpaceTree.Roots.Delete(Root.Index);
    TMainForm(Owner).InclModify(cpFrame);
  end;
end;

end.
