(* OleDragnDrop

Ver, 1.00 2020/12/13 ꉞB
Ver, 1.01 2022/10/22 TDropTarget.DragKey ǉBpbgy[WύXB

OLE Drag And Drop ΉR|[lgWB
ۂɂ IDropTarget, IEnumFormatEtc, IDataObject, IDropSource bvăC^[tF[X̃RsyyɂB
{Iɂ̓C^[tF[X𒼐ڎgpĂ鎞ƕςȂB

IDragSourceHelper, IDropTargetHelper, IDataObjectAsyncCapability ɂ͖ΉB

TDropTarget
IDropTarget bp[B
Winapi.ActiveX.RegisterDragDrop Ŏ󂯓Jn Winapi.ActiveX.RevokeDragDrop ŏIB

vpeB
DragKey;    OnDTDragEnter, OnDTDragOver ̃L[Xe[gێB
DragEffect; OnDTDragEnter ̃hbvGtFNgێB

̂ق̃vpeBACxgA\bh TComponent  IDropTarget ƓB

TDataObject
IEnumFormatEtc  IDataObject ̃bp[B
IDataObject ɂ̓f[^̊Ǘ@\͂Ȃ炵̂ŁA̕ӂǉB

vpeB
Assoc;        TListItem.Data ȂǂƓǁAData ƖOԂ̂ŉB
Count;        TFormatEtc ̓o^B
Formats;      o^Ă TFormatEtc
FormatIndex;  Qƒ Formats ̃CfbNXB
Mediums;      o^Ă TStgMedium

\bh
Clear;        f[^ׂč폜B
Add;          f[^ǉB
Delete;       f[^폜B
IndexOf;      f[^̃CfbNXԂB

̂ق̃vpeBACxgA\bh TComponent  IEnumFormatEtc, IDataObject ƓB

TDropSource
IDropSource bp[B
TDataObject ƃyAŎgpAWinapi.ActiveX.DoDragDrop ŃhbNJnB
DoDragDrop ̓}EXƐIɃLv`[̂ŁAق̃EBhEɃ}EXbZ[W͂ȂB
I[gXN[zbggbN TDropTarget.OnDTDragOver ȂǂŔ\IɌĂяoƁB

vpeBACxgA\bh TComponent  IDropSource ƓB

  OLE Drag'nDrop *)

unit OleDragnDrop;

interface

uses
  System.SysUtils, System.Classes, Winapi.Windows, Winapi.ActiveX, Vcl.Controls,
  System.Generics.Collections;

type
  TDTDragEnter = procedure(const dataObj: IDataObject; grfKeyState: Longint; pt: TPoint;
    var dwEffect: Longint; var Result: HResult) of object;
  TDTDragOver = procedure(grfKeyState: Longint; pt: TPoint;
    var dwEffect: Longint; var Result: HResult) of object;
  TDTDragLeave = procedure (var Result: HResult) of object;
  TDTDrop = procedure(const dataObj: IDataObject; grfKeyState: Longint; pt: TPoint;
    var dwEffect: Longint; var Result: HResult) of object;

  TDropTarget = class(TComponent, IDropTarget)
  private
    { Private 錾 }
    FDragKey,
    FDragEffect: LongInt;
    FOnDTDragEnter: TDTDragEnter;
    FOnDTDragOver: TDTDragOver;
    FOnDTDragLeave: TDTDragLeave;
    FOnDTDrop: TDTDrop;
  protected
    { Protected 錾 }
    //IDropTarget
    function DragEnter(const dataObj: IDataObject; grfKeyState: Longint;
      pt: TPoint; var dwEffect: Longint): HResult; stdcall;
    function IDropTarget.DragOver = IDragOver;
    function IDragOver(grfKeyState: Longint; pt: TPoint;
      var dwEffect: Longint): HResult; stdcall;
    function DragLeave: HResult; stdcall;
    function Drop(const dataObj: IDataObject; grfKeyState: Longint; pt: TPoint;
      var dwEffect: Longint): HResult; stdcall;
  public
    { Public 錾 }
    constructor Create(AOwner: TComponent); override;
    destructor Destroy; override;
    property DragKey: LongInt read FDragKey;
    property DragEffect: LongInt read FDragEffect;
  published
    { Published 錾 }
    property OnDTDragEnter: TDTDragEnter read FOnDTDragEnter write FOnDTDragEnter;
    property OnDTDragOver: TDTDragOver read FOnDTDragOver write FOnDTDragOver;
    property OnDTDragLeave: TDTDragLeave read FOnDTDragLeave write FOnDTDragLeave;
    property OnDTDrop: TDTDrop read FOnDTDrop write FOnDTDrop;
  end;

  TEFENext = procedure(celt: Longint; out elt; pceltFetched: PLongint; var Result: HResult) of object;
  TEFESkip = procedure(celt: Longint; var Result: HResult) of object;
  TEFEReset = procedure(var Result: HResult) of object;
  TEFEClone = procedure(out Enum: IEnumFormatEtc; var Result: HResult) of object;

  TDOGetData = procedure(const formatetcIn: TFormatEtc; out medium: TStgMedium; var Result: HResult) of object;
  TDOGetDataHere = procedure(const formatetc: TFormatEtc; out medium: TStgMedium; var Result: HResult) of object;
  TDOQueryGetData = procedure(const formatetc: TFormatEtc; var Result: HResult) of object;
  TDOGetCanonicalFormatEtc = procedure(const formatetc: TFormatEtc; out formatetcOut: TFormatEtc; var Result: HResult) of object;
  TDOSetData = procedure(const formatetc: TFormatEtc; var medium: TStgMedium; fRelease: BOOL; var Result: HResult) of object;
  TDOEnumFormatEtc = procedure(dwDirection: Longint; out enumFormatEtc: IEnumFormatEtc; var Result: HResult) of object;
  TDODAdvise = procedure(const formatetc: TFormatEtc; advf: Longint; const advSink: IAdviseSink; out dwConnection: Longint; var Result: HResult) of object;
  TDODUnadvise = procedure(dwConnection: Longint; var Result: HResult) of object;
  TDOEnumDAdvise = procedure(out enumAdvise: IEnumStatData; var Result: HResult) of object;

  TDataObject = class(TComponent, IEnumFormatEtc, IDataObject)
  private
    { Private 錾 }
    FAssoc: TCustomData;
    FFormats: TList<TFormatEtc>;
    FFormatIndex: Integer;
    FMediums: TList<TStgMedium>;
    FEFENext: TEFENext;
    FEFESkip: TEFESkip;
    FEFEReset: TEFEReset;
    FEFEClone: TEFEClone;
    FDOGetData: TDOGetData;
    FDOGetDataHere: TDOGetDataHere;
    FDOQueryGetData: TDOQueryGetData;
    FDOGetCanonicalFormatEtc: TDOGetCanonicalFormatEtc;
    FDOSetData: TDOSetData;
    FDOEnumFormatEtc: TDOEnumFormatEtc;
    FDODAdvise: TDODAdvise;
    FDODUnadvise: TDODUnadvise;
    FDOEnumDAdvise: TDOEnumDAdvise;
    function GetCount: Integer;
    function GetFormat(Index: Integer): TFormatEtc;
    procedure SetFormat(Index: Integer; Value: TFormatEtc);
    function GetMedium(Index: Integer): TStgMedium;
    procedure SetMedium(Index: Integer; Value: TStgMedium);
  protected
    { Protected 錾 }
    //IEnumFormatEtc
    function Next(celt: Longint; out elt;
      pceltFetched: PLongint): HResult; stdcall;
    function Skip(celt: Longint): HResult; stdcall;
    function Reset: HResult; stdcall;
    function Clone(out Enum: IEnumFormatEtc): HResult; stdcall;
    //IDataObject
    function GetData(const formatetcIn: TFormatEtc; out medium: TStgMedium):
      HResult; stdcall;
    function GetDataHere(const formatetc: TFormatEtc; out medium: TStgMedium):
      HResult; stdcall;
    function QueryGetData(const formatetc: TFormatEtc): HResult;
      stdcall;
    function GetCanonicalFormatEtc(const formatetc: TFormatEtc;
      out formatetcOut: TFormatEtc): HResult; stdcall;
    function SetData(const formatetc: TFormatEtc; var medium: TStgMedium;
      fRelease: BOOL): HResult; stdcall;
    function EnumFormatEtc(dwDirection: Longint; out enumFormatEtc:
      IEnumFormatEtc): HResult; stdcall;
    function DAdvise(const formatetc: TFormatEtc; advf: Longint;
      const advSink: IAdviseSink; out dwConnection: Longint): HResult; stdcall;
    function DUnadvise(dwConnection: Longint): HResult; stdcall;
    function EnumDAdvise(out enumAdvise: IEnumStatData): HResult; stdcall;
  public
    { Public 錾 }
    constructor Create(AOwner: TComponent); override;
    destructor Destroy; override;
    //IDataObject Helper
    procedure Clear;
    procedure Add(const AFormat: TFormatEtc; var AMedium: TStgMedium; ARelease: BOOL);
    procedure Delete(Index: Integer);
    function IndexOf(AFormat: TFormatEtc): Integer;
    property Assoc: TCustomData read FAssoc write FAssoc;
    property Count: Integer read GetCount;
    property Formats[Index: Integer]: TFormatEtc read GetFormat write SetFormat;
    property FormatIndex: Integer read FFormatIndex write FFormatIndex;
    property Mediums[Index: Integer]: TStgMedium read GetMedium write SetMedium;
  published
    { Published 錾 }
    property OnEFENext: TEFENext read FEFENext write FEFENext;
    property OnEFESkip: TEFESkip read FEFESkip write FEFESkip;
    property OnEFEReset: TEFEReset read FEFEReset write FEFEReset;
    property OnEFEClone: TEFEClone read FEFEClone write FEFEClone;
    property OnDOGetData: TDOGetData read FDOGetData write FDOGetData;
    property OnDOGetDataHere: TDOGetDataHere read FDOGetDataHere write FDOGetDataHere;
    property OnDOQueryGetData: TDOQueryGetData read FDOQueryGetData write FDOQueryGetData;
    property OnDOGetCanonicalFormatEtc: TDOGetCanonicalFormatEtc read FDOGetCanonicalFormatEtc write FDOGetCanonicalFormatEtc;
    property OnDOSetData: TDOSetData read FDOSetData write FDOSetData;
    property OnDOEnumFormatEtc: TDOEnumFormatEtc read FDOEnumFormatEtc write FDOEnumFormatEtc;
    property OnDODAdvise: TDODAdvise read FDODAdvise write FDODAdvise;
    property OnDODUnadvise: TDODUnadvise read FDODUnadvise write FDODUnadvise;
    property OnDOEnumDAdvise: TDOEnumDAdvise read FDOEnumDAdvise write FDOEnumDAdvise;
  end;

  TDSQueryContinueDrag = procedure(fEscapePressed: BOOL; grfKeyState: Longint; var Result: HResult) of object;
  TDSGiveFeedback = procedure(dwEffect: Longint; var Result: HResult) of object;

  TDropSource = class(TComponent, IDropSource)
  private
    { Private 錾 }
    FDSQueryContinueDrag: TDSQueryContinueDrag;
    FDSGiveFeedback: TDSGiveFeedback;
  protected
    { Protected 錾 }
    //IDropSource
    function QueryContinueDrag(fEscapePressed: BOOL;
      grfKeyState: Longint): HResult; stdcall;
    function GiveFeedback(dwEffect: Longint): HResult; stdcall;
  public
    { Public 錾 }
    constructor Create(AOwner: TComponent); override;
    destructor Destroy; override;
  published
    { Published 錾 }
    property OnDSQueryContinueDrag: TDSQueryContinueDrag read FDSQueryContinueDrag write FDSQueryContinueDrag;
    property OnDSGiveFeedback: TDSGiveFeedback read FDSGiveFeedback write FDSGiveFeedback;
  end;

//{ pInit  PByte  Ԃl ^IStream Ȃ񂾂ǁB
function SHCreateMemStream(pInit: Pointer; cbInit: UINT): Pointer; stdcall;
  external 'Shlwapi.dll' name 'SHCreateMemStream';

function GenledClipFmt(cfFormat: TClipFormat; ptd: PDVTargetDevice; dwAspect: Longint;
  lindex: Longint; tymed: Longint): TFormatEtc; overload;
function GenledClipFmt(cfFormat: TClipFormat;
  lindex: Longint; tymed: Longint): TFormatEtc; overload;

procedure Register;

implementation

uses
  Winapi.UrlMon;

{ Routine }

// TFormatEtc (generalized clipboard format) 쐬ĕԂB
function GenledClipFmt(cfFormat: TClipFormat; ptd: PDVTargetDevice; dwAspect: Longint;
  lindex: Longint; tymed: Longint): TFormatEtc;
begin
  Result.cfFormat := cfFormat;
  Result.ptd := ptd;
  Result.dwAspect := dwAspect;
  Result.lindex := lindex;
  Result.tymed := tymed;
end;

// ptd = nil, dwAspect = DVASPECT_CONTENT  GenledClipFmt.
function GenledClipFmt(cfFormat: TClipFormat; lindex: Longint; tymed: Longint): TFormatEtc;
begin
  Result := GenledClipFmt(cfFormat, nil, DVASPECT_CONTENT, lindex, tymed);
end;

{ TDropTarget }

constructor TDropTarget.Create(AOwner: TComponent);
begin
  inherited;

  FDragKey := 0;
  FDragEffect := DROPEFFECT_NONE;
end;

destructor TDropTarget.Destroy;
begin

  inherited;
end;

function TDropTarget.DragEnter(const dataObj: IDataObject; grfKeyState: Longint; pt: TPoint;
  var dwEffect: Longint): HResult;
begin
  Result := S_OK;
  if Assigned(FOnDTDragEnter) then
    FOnDTDragEnter(dataObj, grfKeyState, pt, dwEffect, Result);
  FDragKey := grfKeyState;
  FDragEffect := dwEffect;
end;

function TDropTarget.IDragOver(grfKeyState: Longint; pt: TPoint; var dwEffect: Longint): HResult;
begin
  Result := S_OK;
  if Assigned(FOnDTDragOver) then
    FOnDTDragOver(grfKeyState, pt, dwEffect, Result);
  FDragKey := grfKeyState;
end;

function TDropTarget.DragLeave: HResult;
begin
  Result := S_OK;
  if Assigned(FOnDTDragLeave) then
    FOnDTDragLeave(Result);
  FDragKey := 0;
  FDragEffect := DROPEFFECT_NONE;
end;

function TDropTarget.Drop(const dataObj: IDataObject; grfKeyState: Longint; pt: TPoint;
  var dwEffect: Longint): HResult;
begin
  Result := S_OK;
  if Assigned(FOnDTDrop) then
    FOnDTDrop(dataObj, grfKeyState, pt, dwEffect, Result);
  FDragKey := 0;
  FDragEffect := DROPEFFECT_NONE;
end;

{ TDataObject }

constructor TDataObject.Create(AOwner: TComponent);
begin
  inherited;

  FAssoc := nil;
  FFormats := TList<TFormatEtc>.Create;
  FFormatIndex := 0;
  FMediums := TList<TStgMedium>.Create;
end;

destructor TDataObject.Destroy;
begin
  Clear;
  FFormats.Free;
  FMediums.Free;

  inherited;
end;

function TDataObject.Next(celt: Longint; out elt; pceltFetched: PLongint): HResult;
var
  i: Integer;
  Fmt: PFormatEtc;
begin
  Result := E_NOTIMPL;
  if Assigned(FEFENext) then
    FEFENext(celt, elt, pceltFetched, Result);

  if Result = E_NOTIMPL then
  begin
    i := 0;
    Fmt := PFormatEtc(@elt);
    while (i < celt) and (FFormatIndex < FFormats.Count) do
    begin
      Fmt^ := FFormats.Items[FFormatIndex];
      Inc(Fmt);
      Inc(i);
      Inc(FFormatIndex);
    end;
    if Assigned(pceltFetched) then
      pceltFetched^ := i;

    if i = celt then
      Result := S_OK
    else
      Result := S_FALSE;
  end;
end;

function TDataObject.Skip(celt: Longint): HResult;
begin
  Result := E_NOTIMPL;
  if Assigned(FEFESkip) then
    FEFESkip(celt, Result);

  if Result = E_NOTIMPL then
  begin
    if FFormatIndex + celt <= FFormats.Count then
    begin
      Inc(FFormatIndex, celt);
      Result := S_OK;
    end else
    begin
      FFormatIndex := FFormats.Count;
      Result := S_FALSE;
    end;
  end;
end;

function TDataObject.Reset: HResult;
begin
  Result := E_NOTIMPL;
  if Assigned(FEFEReset) then
    FEFEReset(Result);

  if Result = E_NOTIMPL then
  begin
    FFormatIndex := 0;

    Result := S_OK;
  end;
end;

function TDataObject.Clone(out Enum: IEnumFormatEtc): HResult;
begin
  Result := E_NOTIMPL;
  if Assigned(FEFEClone) then
    FEFEClone(Enum, Result);

  if Result = E_NOTIMPL then
  begin
    Result := S_OK;
    try
      Enum := TDataObject.Create(Owner) as IEnumFormatEtc;
      TDataObject(Enum).Assign(Self);
    except
      Result := E_FAIL;
    end;
  end;
end;

function TDataObject.GetCount: Integer;
begin
  Result := FFormats.Count;
end;

function TDataObject.GetFormat(Index: Integer): TFormatEtc;
begin
  Result := FFormats.Items[Index];
end;

procedure TDataObject.SetFormat(Index: Integer; Value: TFormatEtc);
begin
  FFormats.Items[Index] := Value;
end;

function TDataObject.GetMedium(Index: Integer): TStgMedium;
begin
  Result := FMediums.Items[Index];
end;

procedure TDataObject.SetMedium(Index: Integer; Value: TStgMedium);
begin
  FMediums.Items[Index] := Value;
end;

procedure TDataObject.Clear;
begin
  FFormats.Clear;
  FFormatIndex := 0;
  FMediums.Clear;
end;

procedure TDataObject.Add(const AFormat: TFormatEtc; var AMedium: TStgMedium; ARelease: BOOL);
begin
  SetData(AFormat, AMedium, ARelease);
end;

procedure TDataObject.Delete(Index: Integer);
begin
  FFormats.Delete(Index);
  if Index <= FFormatIndex then
  begin
    Dec(FFormatIndex);
    if FFormatIndex < 0 then
      FFormatIndex := 0;
  end;
  FMediums.Delete(Index);
end;

function TDataObject.IndexOf(AFormat: TFormatEtc): Integer;
var
  i: Integer;
begin
  Result := -1;
  for i := 0 to FFormats.Count - 1 do
  begin
    with FFormats.Items[i] do
    begin
      if (cfFormat = AFormat.cfFormat)
        //and (ptd = AFormat.ptd)
        and (dwAspect = AFormat.dwAspect)
        and (lindex = AFormat.lindex)
        and (tymed and AFormat.tymed <> 0) then
      begin
        Result := i;
        Break;
      end;
    end;
  end;
end;

function TDataObject.GetData(const formatetcIn: TFormatEtc; out medium: TStgMedium): HResult;
var
  i: Integer;
begin
  Result := E_NOTIMPL;
  if Assigned(FDOGetData) then
    FDOGetData(formatetcIn, medium, Result);

  if Result = E_NOTIMPL then
  begin
    i := IndexOf(formatetcIn);
    if i >= 0 then
      Result := CopyStgMedium(FMediums.Items[i], medium)
    else
      Result := DV_E_FORMATETC;
  end;
end;

function TDataObject.GetDataHere(const formatetc: TFormatEtc; out medium: TStgMedium): HResult;
begin
  Result := E_NOTIMPL;
  if Assigned(FDOGetDataHere) then
    FDOGetDataHere(formatetc, medium, Result);
end;

function TDataObject.QueryGetData(const formatetc: TFormatEtc): HResult;
var
  i: Integer;
begin
  Result := E_NOTIMPL;
  if Assigned(FDOQueryGetData) then
    FDOQueryGetData(formatetc, Result);

  if Result = E_NOTIMPL then
  begin
    i := IndexOf(formatetc);
    if i >= 0 then
      Result := S_OK
    else
      Result := DV_E_FORMATETC;
  end;
end;

function TDataObject.GetCanonicalFormatEtc(const formatetc: TFormatEtc;
  out formatetcOut: TFormatEtc): HResult;
begin
  Result := E_NOTIMPL;
  if Assigned(FDOGetCanonicalFormatEtc) then
    FDOGetCanonicalFormatEtc(formatetc, formatetcOut, Result);
end;

function TDataObject.SetData(const formatetc: TFormatEtc; var medium: TStgMedium;
  fRelease: BOOL): HResult;
var
  i: Integer;
begin
  Result := E_NOTIMPL;
  if Assigned(FDOSetData) then
    FDOSetData(formatetc, medium, fRelease, Result);

  if Result = E_NOTIMPL then
  begin
    i := IndexOf(formatetc);
    if i < 0 then
    begin
      FFormats.Add(formatetc);
      FMediums.Add(medium);

      Result := S_OK;
    end
    else
      Result := DV_E_FORMATETC;
  end;
end;

function TDataObject.EnumFormatEtc(dwDirection: Longint; out enumFormatEtc: IEnumFormatEtc): HResult;
begin
  Result := E_NOTIMPL;
  if Assigned(FDOEnumFormatEtc) then
    FDOEnumFormatEtc(dwDirection, enumFormatEtc, Result);

  if Result = E_NOTIMPL then
  begin
    enumFormatEtc := Self as IEnumFormatEtc;
    if Assigned(enumFormatEtc) then
      Result := S_OK
    else
      Result := E_NOTIMPL;
  end;
end;

function TDataObject.DAdvise(const formatetc: TFormatEtc; advf: Longint; const advSink: IAdviseSink;
  out dwConnection: Longint): HResult;
begin
  Result := E_NOTIMPL;
  if Assigned(FDODAdvise) then
    FDODAdvise(formatetc, advf, advSink, dwConnection, Result);
end;

function TDataObject.DUnadvise(dwConnection: Longint): HResult;
begin
  Result := E_NOTIMPL;
  if Assigned(FDODUnadvise) then
    FDODUnadvise(dwConnection, Result);
end;

function TDataObject.EnumDAdvise(out enumAdvise: IEnumStatData): HResult;
begin
  Result := E_NOTIMPL;
  if Assigned(FDOEnumDAdvise) then
    FDOEnumDAdvise(enumAdvise, Result);
end;

{ TDropSource }

constructor TDropSource.Create(AOwner: TComponent);
begin
  inherited;

end;

destructor TDropSource.Destroy;
begin

  inherited;
end;

function TDropSource.QueryContinueDrag(fEscapePressed: BOOL; grfKeyState: Longint): HResult;
var
  ButtonPressed: Boolean;
begin
  Result := E_NOTIMPL;
  if Assigned(FDSQueryContinueDrag) then
    FDSQueryContinueDrag(fEscapePressed, grfKeyState, Result);

  if Result = E_NOTIMPL then
  begin
    ButtonPressed := ((grfKeyState and MK_LBUTTON) <> 0) or ((grfKeyState and MK_RBUTTON) <> 0);
    if fEscapePressed and ButtonPressed then
      Result := DRAGDROP_S_CANCEL
    else if not ButtonPressed then
      Result := DRAGDROP_S_DROP
    else
      Result := S_OK;
  end;
end;

function TDropSource.GiveFeedback(dwEffect: Longint): HResult;
begin
  Result := E_NOTIMPL;
  if Assigned(FDSGiveFeedback) then
    FDSGiveFeedback(dwEffect, Result);

  if Result = E_NOTIMPL then
    Result := DRAGDROP_S_USEDEFAULTCURSORS;
end;

procedure Register;
begin
  RegisterComponents('Drags', [TDropTarget, TDataObject, TDropSource]);
end;

end.
